/*******************************************************************************
*   W[      FAvP[VOP O[oϐ            *
*   W[x    Fapp01_InitVar                                        *
*   R[OV[PXFvoid app01_InitVar()                                 *
*   쐬E쐬      F2015/5/6       Y.K.                                  *
*******************************************************************************/
#include "dpu_api.h"
#include "dpu_api_proto.h"
#include "app_core.h"
#include "app_rdn_core.h"

// CMD
unsigned char	app01_Tlm_CmpSet	( unsigned char, unsigned char, unsigned char );

// ***********************
// *** Prototype       ***
// ***********************
unsigned char	app01_InitVar_MEA1();
unsigned char	app01_InitVar_MEA2();
unsigned char	app01_InitVar_MIA();
unsigned char	app01_InitVar_MSA();
unsigned char	app01_InitVar_HEPE();
unsigned char	app01_InitVar_HEPI();
unsigned char	app01_InitVar_ENA();
unsigned char	app01_InitVar_EWO();
unsigned char	app01_InitVar_MEF();
unsigned char	app01_InitVar_MWE();
//
unsigned char	app01_ErrClr_MEA1();
unsigned char	app01_ErrClr_MEA2();
//
unsigned char	app01_InitVar_rdn();
unsigned char	app01_ErrClr_rdn();


unsigned char	app01_InitVar()
{
	int		i;

	// *****************************
	// *** Initialization - MATH ***
	// *****************************
	app_math_init_table();


	// *********************************************************
	// *   Global Variables - DATA                             *
	// *********************************************************
	Guc_OpeMode				= 					// Operation Mode:	0:NRM   1:Cruise		(1bit)
    Guc_Spec_Code			= 0;				// Dummy Telemetry: DIS
	/******* DUMMY-TLM ***********
	Gui_Spec_Code_TI 		= 0;
	******************************/

	// Trigger variable
	Gui_TRG1_Cnt = Gui_TRG2_Cnt = 0;
	for (i=0; i<Gd_TRG_MAX; i++) 	{
		app_TRG_reset( 0, i );		//	Trigger Buffer reset
		app_TRG_reset( 1, i );		//	Trigger Buffer reset
	}
	Gui_TRG_TiLAST = 0;

	// MDM
	Gui_MDM_data_TI		  = 0;				// MDM (for PWI): 	TI of DATA
	Guc_MDM_data_priority = 0;				// MDM (for PWI): 	Priority 	B7(MSB)	1:event	0:noise
											//								B6-B0	Peak
	Gi_MDM_numPacket      = 0;				// MDM - stored packet num.

	// MSASI
	Guc_MSAS_BufClct	  = 0;				// MSASI:	Buff Collect Spin length (00-FF)

	// SOR
	Guc_SOR_LM			  = 0;				// SOR: L/M switch

	// *************************
	// *** App02(HK) Status  ***
	// *************************
	Guc_HK_repEna				= 1;			// HK Rep:          ENA
	Guc_dpuHkMode				= 0;			// HK MODE:			DIS
	Guc_dpuSunMode				= 0;			// SunPulse -- from outside
	for (i=0; i<0x15; i++) {
		Guc_HK_repInt [i]		= 4;			// HK Rep interval: 16 (2^4) sec, ENA
		Guc_HK_OneShot[i]		= 0;			// HK OneShot:      DIS
		Guc_HK_link   [i]		= 0;			// HK SW/link:      DIS
		Guc_HK_link0  [i]		= 0;			// HK SW/link:      DIS
		Guc_TLMhk_cmp [i] 		= 0;			// TLM-HK Dump:	Non compression
	}
	Guc_HK_repInt [Gd_N_MDM]	= Guc_HK_repInt [Gd_N_SOR] = 0xFF;			// HK Rep: 		DIS

	// *************************
	// *** Common: DMA       ***
	// *************************
	Gi_dmaBusyTask	= 0xF8;
	G2i_dmaBusy		=
	G3i_dmaBusy		= G13i_dmaBusy	=
	G4i_dmaBusy		= G14i_dmaBusy	=
	G5i_dmaBusy		= 0;
	Gi_shareBusy	= 0;
	Gi_shareStatus	= 0;


	// *************************
	// *** Common: Telemetry ***
	// *************************
	Gi_cmdBusy 		=  
	Gi_tlmBusyTask	=  0;
	G3i_arithBusy 	=  0;
	G5i_arithBusy 	=  0;
	
	// ************************
	// *** App03-04 Status  ***
	// *** App05 Status     ***
	// ************************
	Guc_TLMm_enadis				= 1;			// TLM-L/M Dump:	ENA
	for (i=0; i<0x13; i++)  {
		Gui_TLMm_blockTime[i] 	= 				// TLM Block TI
		Gui_TLMh_blockTime[i] 	= 0;			// TLM Block TI
		if (i>=Gd_N_MEA1 && i<=Gd_N_SOR) { 
			app_ReleaseBlock( i, 0, 0, -1 );	// ALL - Block clear
			app_ReleaseBlock( i, 0, 1, -1 );	// ALL - Block clear
		}
	}
	app01_Tlm_CmpSet( 0xFF, 0, 0x11 );			// 	Guc_TLMm_cmp [i] = 1;			TLM-L/M Dump:	Arith-0 compression		[0:non  1:Arith-0 2:Arith-1 3:User-defined]
												//	Guc_TLMh_cmp [i] = 1;			TLM-H Dump: 	Arith-0 compression 

	for (i=0; i<0x11; i++)  
		Guc_TLMh_enadis   [i]	= 0;			// TLM-H Dump: DIS				[0:DIS  1:ENA]
	//
	//
	for (i=0; i<3; i++) {
		Gi_TLMh_BusyHeadId     [i]	= 0x1F;
		Gui_TLMh_TIstart       [i] 	= 0xFFFFFFFF;		// [INPUT]	TI - Dump Start
		Gus_TLMh_TIlen         [i]	= 					// [INPUT]	TI - Dump Length 	(0x0000: 1 Packet	0x0001: 1 Block)
		Gui_TLMh_TIdump_start0 [i]  =
		Gui_TLMh_TIdump_end0   [i]	=
		Guc_TLMh_drID          [i]  = 0;
	}

	// Trigger setting		CMD: // MD?U_TLM_H_TRG_SET  (B1:Score-LEN) (B2:Score-th) (B3-4:Para-1) (B5-6:Para-2) (B7-8:Para-3) (B9-10:Para-4) 
	Guc_TLMh_ScoreLen     = Guc_TLMh_ScoreTh  = 0;
	for (i=0; i<4; i++) {
		Guc_TLMh_trgTh[i]  = Guc_TLMh_trgID[i] = 0;
		app_ReleaseBlock( Gd_N_EWO, i, 0, -1 );			// EWO - Block clear
		app_ReleaseBlock( Gd_N_EWO, i, 1, -1 );			// EWO - Block clear
	}
	Guc_TLMh_trgID_num    = 0;

	// Trigger target		// MD?U_TLM_H_TRG_STRT (B1:SEL-DPU1) (B2:SEL-DPU2) (B3:DR-ID) (B4:TI-PRE) (B5:TI-LEN)
	Guc_TLMh_storeId      = 
	Guc_TLMh_storeId1     = 
	Guc_TLMh_storeId2     = 
	Guc_TLMh_storeDrId    = 
	Guc_TLMh_storeDrOvw   = 
	Guc_TLMh_storeTimePre = 
	Guc_TLMh_storeTimeLen = 0;
	// 
	for (i=0; i<6; i++) {
		Guc_TLMh_DrEmpty[i] =				// 				Empty (0:empty)
		Guc_TLMh_DrWrite[i] =				// DR-STATUS	Write (1:write)
		Gui_TLMh_DrTI   [i] =				//				Start TI of the data
		Gui_TLMh_DrScore[i] = 0;			// 			    SCORE
		Guc_TLMh_DrOvw  [i] = 1;			//              Ovw   (1:Ovw-ENA)
	}

	// Triggered Status
	Gui_TRG_TiStart    = 					//	Triggered 	TI-start
	Gui_TRG_TiEnd      = 					//				TI-end
	Gui_TRG_ScoreTotal = 					//				TI-scoreTotal
	Gus_TRG_ScoreTotal =					//				TI-scoreTotal - HK
    Guc_TLMh_DrNum     =					// 				shake-hand status
	Gui_TRG_Score      = 0;


	// ----------------------------
	// PI Init: each
	// ----------------------------
	// == DPU1 ==
	app01_InitVar_MEA1();
	app01_InitVar_MEA2();
	app01_InitVar_MIA();
	app01_InitVar_MSA();
	app01_InitVar_HEPE();
	app01_InitVar_HEPI();
	app01_InitVar_ENA();

	// == DPU2 ==
	app01_InitVar_EWO();
	app01_InitVar_MEF();
	app01_InitVar_MWE();

#ifdef  _APP_RDN_ 
	app01_InitVar_rdn();
#endif // _APP_RDN_ 

	// ************************
	// === Initialization   ===
	// ************************
	app01_BufCollectSet(0xFF,     0);							//  Buffer Collect DIS  [for all NodeID]
	app01_BufOvwSet    (0xFF,     0xFF);						//  Buffer OvrWrt ENA	[for all NodeID / all L/S]
	app01_BufOvwSet    (Gd_N_ENA, 0x00);						//  Buffer OvrWrt DIS	ENA

	return(0);
}



// Flag & Counter: clear
unsigned char	app01_ErrClr()
{
	int		i;

	// ***********************************
	// *** Common : Application Status ***
	// ***********************************
	for (i=0; i<7; i++)  {
//		app_WhoWhere( i, Gd_N_COM, 0xFF );
		Gus_hkApp_overflow[i] =
		Gui_hkApp_counter[i]  = Gui_hkApp_load[i] = Gui_hkApp_loadPeak[i] = 0;	
	}

	for (i=0; i<0x13; i++)  Guc_hkApp_loadNID [i] = Guc_hkApp_loadNIDmax [i] = 0;	
	for (i=0; i<0x15; i++)  Guc_hkApp_loadNID2[i] = Guc_hkApp_loadNIDmax2[i] = 0;	

	// *************************
	// *** Common: Telemetry ***
	// *************************
	for (i=0; i<0x60; i++) {
		Guc_tlmCount[i] = 0;				// TLM Counter
		Gui_tlmTI   [i] = 0;				// TLM TI
	}


	// *************************
	// *** App01(CMD) Status ***
	// *************************
	for (i=0; i<2; i++) {
		Gt_cmdDMC[i].uc_NumBuf        =
		Gt_cmdDMC[i].uc_GetCount      = Gt_cmdDMC[i].uc_GetErr   =
		Gt_cmdDMC[i].uc_ExeCount      = Gt_cmdDMC[i].ui_ExeErr   =
		                                Gt_cmdDMC[i].ui_CntlID   =
		Gt_cmdDMC[i].uc_Ans           = Gt_cmdDMC[i].ui_ExeTime  = 0;
		Gt_cmdDMC[i].uc_NID           = 0x1F;						// non
	}

	// ****************************
	// === PI Error Clear: DPU1 ===
	// ****************************
	// == DPU1 ==
	app01_ErrClr_MEA1();
	app01_ErrClr_MEA2();

	// ****************************
	// === RDN Error Clear
	// ****************************
#ifdef  _APP_RDN_ 
	app01_ErrClr_rdn();
#endif // _APP_RDN_ 

	return(0);
}



/*
unsigned char	app01_JpegSet()
{
	int			i_busyFlag;
	int			i_flag;
	int			i;
	
	i_flag = dpu_setCompParam( &Gt_compParam08bit, &i_busyFlag );
	if (i_flag)				return( -i_flag);		// ***ERR=1 Fsȃrbgx 					compParam.uc_bit 8,12 ȊOB
													// ***ERR=2 Fsȗʎqe[u				compParam.us_QTable[][]0 ݒ肵B
													// ***ERR=3 FsDC nt}e[u			compParam.us_DCT_num 16 傫B
													//												compParam.us_DCTsize[]16 傫B
													// ***ERR=4 FsAC nt}e[u			compParam.us_ACT_num 256 傫B
													//												compParam.us_ACTsize[]16 傫B
													// ***ERR=5 FsȃX^[gC^[o		compParam.us_restartInterval 64 ̔{łȂB
													// ***ERR=6 Fsȃ}[J}w				compParam.uc_marker_QT,uc_markerHT,uc_marker_comment 0,1 ȊOB
													// ***ERR=7 Fsȃ}[JpDC nt}e[u	compParam.uc_markerDCT_Lnum 16 傫B
													//												compParam.uc_markerDCT_Vnum 16 傫B
													// ***ERR=8 Fsȃ}[JpAC nt}e[u	compParam.uc_markerACT_Lnum 16 傫B
													//												compParam.uc_markerACT_Vnum 256 傫B
													// ***ERR=9 F~hEFÄkvǗobt@t̂ߎ󂯕tȂB
	
	for (i=0; i<10; i++)  {
		if (i_busyFlag != 1) break;
		dpu_delay(10);
	}
	if (i_busyFlag==1)		return(11);								// ***ERR=11: dpu_setCompParam	still BUSY
	if (i_busyFlag==-4)		return(12);								// ***ERR=12: dpu_setCompParam	H/W error
	if (i_busyFlag)			return(13);								// ***ERR=12: dpu_setCompParam	unknown

	return(0);
}
*/
