/*******************************************************************************
*   W[      FAPP01 - CMD from DMC to DPU (for 'HEP' task)         *
*   쐬E쐬      F2011/11/27    Y.K.                                   *
*                         2014/01/14    T.T.                                   *
*                         2013/04/16    T.T.                                   *
*   Q                F  app01_DPU.c QƂ̂                           *
*   				F  EDIT́AMPPE/HEPg                             *
********************************************************************************/
#include 	"app_common.h"
#include	"app_MPPE-HEP.h"


// *** Prototype - HEPE ***
unsigned char	app01_HEPE            ( unsigned int,  unsigned char * , int);
//
unsigned char	app01_InitVar_HEPE    ( void );
unsigned char	app01_ErrClr_HEPE     ( void );

// *** Prototype - HEPI ***
unsigned char	app01_HEPI            ( unsigned int,  unsigned char * , int);
//
unsigned char	app01_InitVar_HEPI    ( void );
unsigned char	app01_ErrClr_HEPI     ( void );



// **************************************
// *** HEPE: CMD analyses / execution ***
// **************************************
unsigned char	app01_HEPE  ( unsigned int ui_Cntl, unsigned char uc_Data[], int i_Size )
{
	unsigned char	uc_flag = 0;

	if(ui_Cntl == 0x0000){
		// --------------------------------------------------------
		// ----- Admin --------------------------------------------
		// --------------------------------------------------------
		if (i_Size!=0) return(0xFF);
		   uc_flag = app01_InitVar_HEPE(); // MD*U_HEPE_INIT
	}else if(ui_Cntl == 0x8001){
		if (i_Size !=0 ) return(0xFF); // ASIC Initialize
			Guc_HEPE_INIT_ASIC_flag = 1;
		        Guc_HEPE_INIT_ASIC_cnt = 0;
	}else if(ui_Cntl == 0x8002){
		if (i_Size !=0 ) return(0xFF); //Temp table set 
			Guc_HEPE_INIT_TEMP_para_flag = 1;
		        Guc_HEPE_INIT_TEMP_para_cnt = 0;
        }else{
	     uc_flag = 0xFF;	// *** Error: CMD not found ***
	}

	return( uc_flag );
}
// ****************************************************************************************************



// **************************************
// *** HEPI: CMD analyses / execution ***
// **************************************
unsigned char	app01_HEPI  ( unsigned int ui_Cntl, unsigned char uc_Data[], int i_Size )
{
	unsigned char	uc_flag = 0;

	if(ui_Cntl == 0x0000){
		// --------------------------------------------------------
		// ----- Admin --------------------------------------------
		// --------------------------------------------------------
		if (i_Size!=0) return(0xFF);
			uc_flag = app01_InitVar_HEPI();		// MD*U_HEPI_INIT
	}else if(ui_Cntl == 0x8001){
		if (i_Size !=0 ) return(0xFF); // ASIC Initialize
			Guc_HEPI_INIT_ASIC_flag = 1;
		        Guc_HEPI_INIT_ASIC_cnt = 0;
	}else if(ui_Cntl == 0x8002){
		if (i_Size !=0 ) return(0xFF); //Temp table set 
			Guc_HEPI_INIT_TEMP_para_flag = 1;
		        Guc_HEPI_INIT_TEMP_para_cnt = 0;
	}else if(ui_Cntl == 0xA000){
		if (i_Size < 1 ) return(0xFF); // Calibration mode set
		  Guc_HEPI_process_packet_MAX_num = uc_Data[0]+uc_Data[1];  //20130416 add
	}else if(ui_Cntl == 0xFF01){	
		// if(i_Size <1 ) {break;} // USER-REQ COM test
			// Guc_HEPI_USR_REQ_COM_flg = 1;
			Guc_HEP_TLM_stack_num_max = 4 ; // add 20180108
			Gus_HEP_timer_counter = 0 ; // add 20180108
        }else{
		uc_flag = 0xFF;		// *** Error: CMD not found ***
	}

	return( uc_flag );
}
// ***************************************************************************************************
