/*******************************************************************************
*   W[      FAvP[V02 - HK read & anaylses - MGF        *
*   Ql                Fapp02_DPU.c Q                                   *
*   				FEDIT́AMGFg                                    *
*   쐬E쐬      F2010/07/21    Y.K.                                   *
*                       F2012/1/7      rev. by YK                             *
*   E      F2012/06/03    A. Matsuoka                            *
*   E      F2013/01/10    A. Matsuoka MGF-O Mirror write C    *
*   E      F2013/11/19    A. Matsuoka                            *
*******************************************************************************/

#include "app_common.h"
#include "app_MGF.h"

#define		d_SIZEhk_MGFO		128		// HK-size	0x2E
#define		d_SIZEhk_MGFI		128		// HK-size	7


// ********************************************************************
// *** MGFO :  HK analyses, HW CMD production, HK packet production ***
// ********************************************************************
int		app02_MGFO ( unsigned char  uc_dataHK[], unsigned int ui_counter, unsigned char uc_link)
{
//	unsigned char	uc_dpuSwHk[0x100];			// ----- corrected by YK: ȍ~ׂG2uc_packetɍւ -----
	int				i_dpuSwHK_size = 0;
	int				i;					// , k ;				***** REMOVED!  YK  20110721 ******
	unsigned char	uc_flag = 0;
	
	unsigned char	cmd_buf[20];
	int				cmd_num;
	
	#ifdef TLM_STAT
	union uni_long {
		long l ;
		unsigned long ul ;
		unsigned char uc[4] ;
	} u_long ;
	#endif
	
	// *************************
	// ***	HW HK analyses   ***
	// *************************
	if ( uc_link ) {
		// --- HW-ON  ---
		
		// Guc_MGF_HK[0][0]++;  // Counter
		//Guc_MGFO_HK[1]=Guc_MGFI_Sw_Param[0];  // SW Parameter Copy
		//Guc_MGFO_HK[2]=Guc_MGFI_Sw_Param[1];
		//Guc_MGFO_HK[3]=Guc_MGFI_Sw_Param[2];
		//Guc_MGFO_HK[4]=Guc_MGFI_Sw_Param[3];
		
		// Software HK Output
		for (i=0; i<20; i++) {  // 20120603
			G2uc_packet[i]=Guc_MGF_HK[0][i];
		}
		i_dpuSwHK_size=20;  // 20120603
		
	} else {
		// --- HW-OFF ---
		for (i=0; i<d_SIZEhk_MGFO; i++)  uc_dataHK[i] = 0;
	}

	// *************************
	// ***	SW/HK production ***
	// *************************
	if ( uc_link ) {
		// --- HW-ON  ---
		if(0<Gl_MGFO_Cmm_n) {
			cmd_buf[0]=Guc_MGFO_Cmm_Param[0][0];
			cmd_buf[1]= 0 ;
			// cmd_buf[2]=Guc_MGFO_Cmm_Param[0][1];
			// cmd_buf[3]=Guc_MGFO_Cmm_Param[0][2];
			memcpy(&cmd_buf[2], &Guc_MGFO_Cmm_Param[0][1], 2) ;
			cmd_num=4;
			uc_flag = app_PiCmd(Gd_N_MGFO, cmd_buf, cmd_num ); // Command Execution
			Gl_MGFO_Cmm_n-- ;
			for(i=0;i<Gl_MGFO_Cmm_n;i++) {
				// Guc_MGFO_Cmm_Param[i][0] = Guc_MGFO_Cmm_Param[i+1][0] ;
				// Guc_MGFO_Cmm_Param[i][1] = Guc_MGFO_Cmm_Param[i+1][1] ;
				// Guc_MGFO_Cmm_Param[i][2] = Guc_MGFO_Cmm_Param[i+1][2] ;
				memcpy(Guc_MGFO_Cmm_Param[i], Guc_MGFO_Cmm_Param[i+1], 3) ;
			}
		} else if(0<Gl_MGFO_Mrr_n) {
			// cmd_buf[0]= 0x0C ;
			// cmd_buf[1]=Guc_MGFO_Mrr_Param[0][0];
			// cmd_buf[2]=Guc_MGFO_Mrr_Param[0][1];
			// cmd_buf[3]=Guc_MGFO_Mrr_Param[0][2];
			// memcpy(&cmd_buf[1], Guc_MGFO_Mrr_Param[0], 3) ;
			cmd_buf[0]=Guc_MGFO_Mrr_Param[0][0];  // 20130111 ǉ
			cmd_buf[1]= 0 ;  // 20130111 ǉ
			memcpy(&cmd_buf[2], &Guc_MGFO_Mrr_Param[0][1], 2) ;  // 20130111 ǉ
			cmd_num=4;
			uc_flag = app_PiCmd(Gd_N_MGFO, cmd_buf, cmd_num ); // Command Execution
			Gl_MGFO_Mrr_n-- ;
			for(i=0;i<Gl_MGFO_Mrr_n;i++) {
				// Guc_MGFO_Mrr_Param[i][0] = Guc_MGFO_Mrr_Param[i+1][0] ;
				// Guc_MGFO_Mrr_Param[i][1] = Guc_MGFO_Mrr_Param[i+1][1] ;
				// Guc_MGFO_Mrr_Param[i][2] = Guc_MGFO_Mrr_Param[i+1][2] ;
				memcpy(Guc_MGFO_Mrr_Param[i], Guc_MGFO_Mrr_Param[i+1], 3) ;
			}
		}  // match with else if(0<Gl_MGFO_Mrr_n)
		#ifdef TLM_STAT
		u_long.l = Gl_MGFO_Cmm_n ;
		Guc_MGF_TLM_stat[0][87] = u_long.uc[3] ;  // Gl_MGFO_Cmm_n history
		u_long.l = Gl_MGFO_Mrr_n ;
		Guc_MGF_TLM_stat[0][89] = u_long.uc[3] ;  // Gl_MGFO_Cmm_n history
		#endif
	} else {
		// --- HW-OFF ---
	}

	// *****************************
	// ***	HK Packet production ***
	// *****************************
	if ( i_dpuSwHK_size > 0)	memcpy( &uc_dataHK[d_SIZEhk_MGFO], G2uc_packet, i_dpuSwHK_size );
	else						i_dpuSwHK_size = 0;

	// ******************************
	// ***	HK Production in 'OFF ***
	// ******************************
	if ( uc_link == 0 ) return( 0 );
	else			    return( d_SIZEhk_MGFO+i_dpuSwHK_size );
}



// ********************************************************************
// *** MGFI :  HK analyses, HW CMD production, HK packet production ***
// ********************************************************************
int		app02_MGFI ( unsigned char  uc_dataHK[], unsigned int ui_counter, unsigned char uc_link)
{
//	unsigned char	uc_dpuSwHk[0x100];			// ----- corrected by YK: ȍ~ׂG2uc_packetɍւ -----
	int				i_dpuSwHK_size = 0;
	int				i;
	unsigned char	uc_flag = 0;
	
	unsigned char	cmd_buf[20];
	int				cmd_num;
	
	#ifdef TLM_STAT
	union uni_long {
		long l ;
		unsigned long ul ;
		unsigned char uc[4] ;
	} u_long ;
	#endif

	// *************************
	// ***	HW HK analyses   ***
	// *************************
	if ( uc_link ) {
		// --- HW-ON  ---
		
		// Guc_MGF_HK[1][0]++;  // Counter
		//Guc_MGFI_HK[1]=Guc_MGFI_Sw_Param[0];  // SW Parameter Copy
		//Guc_MGFI_HK[2]=Guc_MGFI_Sw_Param[1];
		//Guc_MGFI_HK[3]=Guc_MGFI_Sw_Param[2];
		//Guc_MGFI_HK[4]=Guc_MGFI_Sw_Param[3];
		
		// Software HK Output
		for (i=0; i<20; i++) {  // 20120603
			G2uc_packet[i]=Guc_MGF_HK[1][i];
		}
		i_dpuSwHK_size=20;  // 20120603

	} else {
		// --- HW-OFF ---
		for (i=0; i<d_SIZEhk_MGFI; i++)  uc_dataHK[i] = 0;
	}

	// *************************
	// ***	SW/HK production ***
	// *************************
	if ( uc_link ) {
		// --- HW-ON  ---
		if(2==Gl_MGFI_Cmm_n) {
			cmd_buf[0]=0x12; // Phase set Command Code
			// cmd_buf[1]=Guc_MGFI_Cmm_Param[0]; // Phase X
			// cmd_buf[2]=Guc_MGFI_Cmm_Param[1]; // Phase Y
			// cmd_buf[3]=Guc_MGFI_Cmm_Param[2]; // Phase Z
			memcpy(&cmd_buf[1], Guc_MGFI_Cmm_Param, 3) ;
			cmd_num=4;
			uc_flag = app_PiCmd(Gd_N_MGFI, cmd_buf, cmd_num );  // Command Execution
			Gl_MGFI_Cmm_n = 1 ;
		} else if(1==Gl_MGFI_Cmm_n) {
			cmd_buf[0]=0x14; // Delay set Command Code
			cmd_buf[1]=Guc_MGFI_Cmm_Param[3]; // Delay
			cmd_num=2;
			uc_flag = app_PiCmd(Gd_N_MGFI, cmd_buf, cmd_num );  // Command Execution
			Gl_MGFI_Cmm_n = 0 ;
		}
		
		#ifdef TLM_STAT
		u_long.l = Gl_MGFI_Cmm_n ;
		Guc_MGF_TLM_stat[1][87] = u_long.uc[3] ;
		#endif
	} else {
		// --- HW-OFF ---
	}

	// *****************************
	// ***	HK Packet production ***
	// *****************************
	if ( i_dpuSwHK_size > 0)	memcpy( &uc_dataHK[d_SIZEhk_MGFI], G2uc_packet, i_dpuSwHK_size );
	else						i_dpuSwHK_size = 0;

	// ******************************
	// ***	HK Production in 'OFF ***
	// ******************************
	if ( uc_link == 0 ) return( 0 );
	else				return( d_SIZEhk_MGFI+i_dpuSwHK_size );
}
