/*******************************************************************************
*   W[      Fapp13 Mission TLM (L&M) PI tasks                     *
*   W[x    Fapp13_PIs                                            *
*   ^XN敪          FApplication-03  EWO-EFD task for Mission TLM (L&M)   *
*   @\                F                                                     *
*   R[OV[PXFvoid app13_(PI)                                      *
*                   FȂ                                                 *
*   ߂l              FȂ                                                 *
*   gp̒        FO[oϐ̓AvP[VOPł܂Ƃ߂ď *
*   G[          FȂ                                                 *
*   				F  EDIT́AEWOg                                  *
*   쐬E쐬      F2015/10/6     T.Imachi (H-dump flag)                 *
*******************************************************************************/
#include "app_core.h"
#include "app_EWO.h"
#include "dpu_api_proto.h"

/*******************************************************************************
WFC header (L, M) + data

00 (0x00)	Sun pulse TI
01 (0x01)	Sun pulse TI
02 (0x02)	Sun pulse TI
03 (0x03)	Sun pulse TI
04 (0x04)	EWO Count	(= HB << 4 | LB >> 4)
05 (0x05)	Spec
06 (0x06)	Info0
07 (0x07)	Info1
08 (0x08)	Number of the data in each spectrum
09 (0x09)	Number of the data in each spectrum
10 (0x0A)	Data size
11 (0x0B)	Data size
12 (0x0C)	Data -

WFC header : Info0 (L, M)

b7	Bitrate			0x01:H, 0x02:L, 0x03:M
b6	Bitrate
b5	Time interval	0x00:1/0.5, 0x01:2/1, 0x02:4/2	(L/M)
b4	Time interval
b3	Sampling rate	0x00:LF, 0x01:HF
b2	OFA Channel		0x00:|E|/|B|, 0x01:E1/Bx, 0x02:E2/By, 0x03:NA/Bz	(E/B)
b1	OFA Channel
b0	CAL on/off		0x00:off, 0x01:on

WFC header : Info1 (L, M)

B7	None
B6	None
B5	None
B4	None
B3	None
B2	Pre-Amp gain	0x00:L, 0x01:H
B1	OFA/WFC gain	0x00:L/L, 0x01:ML/H, 0x02:MH/NA, 0x03:H/NA	(E/B)
B0	OFA/WFC gain
*******************************************************************************/

//#define	TLM_DATA_TOP	12
#define	TLM_DATA_TOP	10
	
// [J֐vg^Cv錾
void app13_EWO_readHK();
void app13_OFA( unsigned char uc_OFA_EB, unsigned int ui_sunpulseCnt );
int app13_EWO_OFA_param_check(
	unsigned char *cur,		// [INPUT/OUTPUT] ݂̃p[^l
	unsigned char new		// [INPUT] Vp[^l
	);
void app13_EWO_OFA_make_spectrum(
		unsigned char	uc_OFA_EB,			// [INPUT] OFA-E or OFA-B
		unsigned char	*uc_data,			// [INPUT] ̓f[^obt@i֐ŏ㏑ėpj
		unsigned int	ui_data_size,		// [INPUT] ̓f[^̑傫iBytej
		unsigned char	*uc_ofa_channel,	// [INPUT] L,M1,M2 ̃`li0:ABS,1:X,2:Y,3:Zj
		unsigned char	**uc_tlm_buf,		// [INPUT/OUTPUT] egpPbgobt@
		int				**i_tlm_size,		// [INPUT/OUTPUT] egpPbgobt@̃TCY
		unsigned char	**uc_tlm_ready		// [OUTPUT] Telemtry packet ready
	);
void app13_EWO_spectrum_reduce(
	double		*f_buf,				// [OUTPUT] f[^o̓obt@
	double		*f_re,					// [INPUT] XyNg̔z
	double		*f_im,					// [INPUT] XyNg̔z
	int			i_data_length,			// [INPUT] XyNg_
	int			*i_freq_table,			// [INPUT] ωge[u
	int			i_freq_table_length		// [INPUT] ωge[u
	);
void app13_EWO_spectrum_dB(
	unsigned char	*uc_buf,	// [OUTPUT] o͐obt@
	double	*f_data,			// [INPUT] f[^iXyNgPx̓lj
	int		i_num_data,			// [INPUT] f[^̐
	int		i_div				// [INPUT] Zl
	);
void app13_EWO_OFA_make_tlm_header(
	EWO_PACKET_INFO	*st_tlm_info1,	// [INPUT] eg
	EWO_PACKET_INFO	*st_tlm_info2,	// [INPUT] eg
	unsigned int	ui_spinrate,	// [INPUT] Spin rate
	unsigned char	uc_TI2,			// [INPUT] EWO counter (reduced)
	int				i_size,			// [INPUT] egTCY
	unsigned char	*uc_buf			// [OUTPUT] egpPbgobt@
	);
void app13_EWO_freq_table_init(
	int		*i_freq_table,		// ge[u擪|C^
	int		i_table_size_org,	// X̎ge[u̓_
	int		i_table_size_out,	// ge[u̓_
	double	f_fmax_org,			// X̃e[u̍őg
	double	f_fmax_out			// ge[u̍őg
	);
void app13_EWO_AGC(
	unsigned int	ui_sunpulseCnt,
	unsigned char	uC_OFA_EB
	);
void app13_EWO_ISDM_table_dump();
// ----------------------------------------------------------------------------


/*******************************************************************************
	C֐ (EWO-E)
*******************************************************************************/
void app13_EWOE( unsigned int ui_sunpulseCnt )
{
	app13_EWO_ISDM_table_dump();

	G14uc_AM2P_ready    = 1;
	G14uc_WFC_CAL_ready = 1;

	app13_EWO_readHK();
	app13_OFA( Gd_EWO_OFA_E, ui_sunpulseCnt );
	app13_EWO_AGC( ui_sunpulseCnt, Gd_EWO_OFA_E );
}


/*******************************************************************************
	C֐ (EWO-B)
*******************************************************************************/
void app13_EWOB( unsigned int ui_sunpulseCnt )
{
	app13_EWO_readHK();
	app13_OFA( Gd_EWO_OFA_B, ui_sunpulseCnt );
	app13_EWO_AGC( ui_sunpulseCnt, Gd_EWO_OFA_B );
}


/*******************************************************************************
	EWO HK ̓ǂݍ
*******************************************************************************/
void app13_EWO_readHK(){
	unsigned char	uc_HK[0x80];
	unsigned char	uc_WPTP_gain, uc_WFCE_gain, uc_WFCB_gain;
	int				i_flag;
	int				i;
	
	i_flag = app_HkRead( Gd_N_EWO, uc_HK );
	if( i_flag == 0 ){
		// WFC-E ̓`l :: WFC_E_INP_SEL (Byte:02, Bit:04, Size:02)
		G13uc_WFCE_input_select = ( uc_HK[0x02] & 0x0c ) >> 2;
		// WFC-B LF :: WFC_B_LPF_STS (Byte:01, Bit:06, Size:01)
		if( ( uc_HK[0x01] & 0x02 ) == 0 )	G13uc_WFCB_LF = 1;	// WFC-B FIR 0x00:OFF, 0x01:ON
		else								G13uc_WFCB_LF = 0;
		// QC
		// WPTP_GAIN (Byte:00, Bit:05, Size:01)
		uc_WPTP_gain = ( uc_HK[0x00] & 0x04 ) >> 2;
		// WFC_E_PGA_STS (Byte:02, Bit:01, Size:02)
		uc_WFCE_gain = ( uc_HK[0x02] & 0x60 ) >> 5;
		// WFC_B_PGA_STS (Byte:01, Bit:05, Size:01)
		uc_WFCB_gain = ( uc_HK[0x01] & 0x04 ) >> 2;
		// egXV
		for( i=0; i<3; i++ ){
			G13st_WFCE_tlm_info[i].uc_pre_gain = uc_WPTP_gain;
			G13st_WFCE_tlm_info[i].uc_ofa_gain = uc_WFCE_gain;
			G13st_WFCB_tlm_info[i].uc_pre_gain = 0;
			G13st_WFCB_tlm_info[i].uc_ofa_gain = uc_WFCB_gain;
		}
	}
	
	return;
	
	//	Bin:	7		6		5		4		3		2		1		0
	//	SIB:	0		1		2		3		4		5		6		7
}


/*******************************************************************************
	OFA-E/B ̏
*******************************************************************************/
void app13_OFA( unsigned char uc_OFA_EB, unsigned int ui_sunpulseCnt ){
	unsigned int	ui_timeData;
	int				i_bufId;
	int				i_numNewBlock;
	int				i_lastProcBlock;
	M_T_BLOCK_INFO	t_blockInfo;	// **** M_T_BLOCK_INFO o *****
									// unsigned int	ui_createTime	Block Jnq (LSB=31.25ms)
									// int			i_replyNum		Block o^ read-reply 
									// char			c_invalidFlg	Block f[^ُ̗L (0:ُȂ, 1:ُ킠)
									// unsinged int	ui_blockIndex	LongBuffer/ShortBuffer  Block ԍ
									// ********************************

	int					i_nodeId;			// NodeID ( Gd_N_EWO )
	int					i_dataId;			// DataID ( Gd_D_EWOE or Gd_D_EWOB )
	int					i_headId;			// HeadID ( Gd_N_EWOE or Gd_N_EWOB )

	int					i_packet_dataId;	// EWO packet data ID
	int					i_dataSize;			// EWO packet f[^TCY

	unsigned int		ui_TI1;				// 4 Bytes, LSB: 1.953ms
	unsigned int		ui_TI2;				// 2 Bytes, LSB: 122us
	unsigned char		uc_TI2;				// ( EWO_CNT[0] << 4 ) + ( EWO_CNT[1] >> 4 )
	
	unsigned int		ui_spin_period;		// XsD2048 (0x0800) = 4sec
	double				f_spin_period;		// Xsibj
	int					i_nPacket_1spin;	// P̃pPbg

	int					i_packet_size;		// f[^pPbgTCY

	int					i_num_offset;		// ubN擪̃pPbgǂݔ΂
	int					i_num_skip;			// pPbgǂݔ΂Ԋu
	int					i_num_read;			// ǂݏopPbg
	int					i_num_read_base;	// ǂݏopPbgvZl
	int					i_num_data;			// ǂݏoς݃pPbgf[^
	
	unsigned char		uc_ofa_channel[3];	// OFA `li0,1.2 = L,M1,M2j
	
	unsigned char		*uc_tlm_buf[3];		// egf[^obt@i0,1.2 = L,M1,M2j
	int					*i_tlm_size[3];		// egf[^obt@̃TCY
	EWO_PACKET_INFO		*st_tlm_info[3];	// egpPbg
	int					uc_tlm_bitrate[3];	// L:2, M:3
	unsigned char		*uc_tlm_ready[3];	// Telemtry packt ready
	
	// ėp
	int		i_flag;
	int		i_int_chg;
	int		i;
	
	// ge[u_
	int		i_n_freq_table_def_E_L[3] = { 18, 36, 72 };		// OFA-E L-mode
	int		i_n_freq_table_def_E_M[3] = { 90, 180, 360 };	// OFA-E M-mode
	int		i_n_freq_table_def_B_L[3] = { 18, 36, 72 };		// OFA-B L-mode
//	int		i_n_freq_table_def_B_M[3] = { 180, 360, 720 };	// OFA-B M-mode
	int		i_n_freq_table_def_B_M[3] = { 90, 180, 360 };	// OFA-B M-mode		OFA-E Ɠɂ	2012.08.09
	
	// pPbgǂݔ΂̊
	int		i_n_skip_base[3] = { 1, 2, 4 };
	
	// WFC-E HF [v
	int		i_n_loop[3] = { 4, 2, 1 };
	int		i_loop_count;
	
	// -------------------------------------------------------------------------
	// 
	// -------------------------------------------------------------------------

	i_nodeId = Gd_N_EWO;

	// f[^pPbgǂݏo֌W
	i_num_offset = 0;			// ubN擪̃pPbgǂݔ΂i_~[lDɌvZj
	i_num_skip = 0;				// pPbgǂݔ΂Ԋui_~[lDɌvZj
	i_num_read_base = 4;		// ǂݏopPbgvZli4 packets = 2048 pointsj
	i_num_data = 0;				// ǂݏoς݃pPbgf[^i_~[lDɌvZj

	// egpPbg֌W
	
	// Bitrate
	uc_tlm_bitrate[0] = 2;	// L
	uc_tlm_bitrate[1] = 3;	// M1
	uc_tlm_bitrate[2] = 3;	// M2
	
	// 
	if( G13i_WFC_freq_table_ready == 0 ){
		for( i=0; i<3; i++ ){
			G13i_WFCE_tlm_size[i] = TLM_DATA_TOP;
			G13i_WFCB_tlm_size[i] = TLM_DATA_TOP;
		}
	}
	
	// EWO-E/B ʐݒ
	if( uc_OFA_EB == Gd_EWO_OFA_E ){
		// @ ID ֌W
		i_dataId = Gd_D_EWOE;
		i_headId = Gd_N_EWOE;
		// TI
		G13ui_EWO_TI1 = &G13ui_EWOE_TI1;
		G13us_EWO_TI2 = &G13us_EWOE_TI2;
		G13uc_EWO_TI2 = &G13uc_EWOE_TI2;
		G13uc_EWO_dataId = &G13uc_EWOE_dataId;
		// f[^pPbgTCY
		i_packet_size = Gd_Pac_EWOE;
		// OFA `l
		uc_ofa_channel[0] = G13uc_WFCE_L_channel;
		uc_ofa_channel[1] = G13uc_WFCE_M1_channel;
		uc_ofa_channel[2] = G13uc_WFCE_M2_channel;
		// ge[u
		G13i_WFCE_freq_table_length_L = i_n_freq_table_def_E_L[G13uc_WFC_OFA_interval];
		G13i_WFCE_freq_table_length_M = i_n_freq_table_def_E_M[G13uc_WFC_OFA_interval];
		G13i_WFC_freq_table[0] = G13i_WFCE_freq_table_L;
		G13i_WFC_freq_table[1] = G13i_WFCE_freq_table_M;
		G13i_WFC_freq_table[2] = G13i_WFCE_freq_table_M;
		G13i_WFC_freq_table_length[0] = G13i_WFCE_freq_table_length_L;
		G13i_WFC_freq_table_length[1] = G13i_WFCE_freq_table_length_M;
		G13i_WFC_freq_table_length[2] = G13i_WFCE_freq_table_length_M;
		// egpPbgobt@
		uc_tlm_buf[0] = G13uc_WFCE_L;
		uc_tlm_buf[1] = G13uc_WFCE_M1;
		uc_tlm_buf[2] = G13uc_WFCE_M2;
		// egpPbg݃|C^
		// egpPbgobt@̃TCY
		for( i=0; i<3; i++ ){
			i_tlm_size[i] = &G13i_WFCE_tlm_size[i];
			st_tlm_info[i] = &G13st_WFCE_tlm_info[i];
			uc_tlm_ready[i] = &G13uc_EWOE_OFA_tlm_ready[i];
		}
	}
	else{
		// @ ID ֌W
		i_dataId = Gd_D_EWOB;
		i_headId = Gd_N_EWOB;
		// TI
		G13ui_EWO_TI1 = &G13ui_EWOB_TI1;
		G13us_EWO_TI2 = &G13us_EWOB_TI2;
		G13uc_EWO_TI2 = &G13uc_EWOB_TI2;
		G13uc_EWO_dataId = &G13uc_EWOB_dataId;
		// f[^pPbgTCY
		i_packet_size = Gd_Pac_EWOB;
		// OFA `l
		uc_ofa_channel[0] = G13uc_WFCB_L_channel;
		uc_ofa_channel[1] = G13uc_WFCB_M1_channel;
		uc_ofa_channel[2] = G13uc_WFCB_M2_channel;
		// ge[u
		G13i_WFCB_freq_table_length_L = i_n_freq_table_def_B_L[G13uc_WFC_OFA_interval];
		G13i_WFCB_freq_table_length_M = i_n_freq_table_def_B_M[G13uc_WFC_OFA_interval];
		G13i_WFC_freq_table[0] = G13i_WFCB_freq_table_L;
		G13i_WFC_freq_table[1] = G13i_WFCB_freq_table_M;
		G13i_WFC_freq_table[2] = G13i_WFCB_freq_table_M;
		G13i_WFC_freq_table_length[0] = G13i_WFCB_freq_table_length_L;
		G13i_WFC_freq_table_length[1] = G13i_WFCB_freq_table_length_M;
		G13i_WFC_freq_table_length[2] = G13i_WFCB_freq_table_length_M;
		// egpPbgobt@
		uc_tlm_buf[0] = G13uc_WFCB_L;
		uc_tlm_buf[1] = G13uc_WFCB_M1;
		uc_tlm_buf[2] = G13uc_WFCB_M2;
		// egpPbg݃|C^
		// egpPbgobt@̃TCY
		for( i=0; i<3; i++ ){
			i_tlm_size[i] = &G13i_WFCB_tlm_size[i];
			st_tlm_info[i] = &G13st_WFCB_tlm_info[i];
			uc_tlm_ready[i] = &G13uc_EWOB_OFA_tlm_ready[i];
		}
	}
	
	for( i=0; i<3; i++ ){
		(*st_tlm_info[i]).uc_bitrate = uc_tlm_bitrate[i];
		(*st_tlm_info[i]).uc_interval = G13uc_WFC_OFA_interval;
	}

	
	// ̂݁CTRG pge[u
	if( G13i_WFC_freq_table_ready == 0 ){
		app13_EWO_freq_table_init(
			G13i_WFC_freq_table_TRG,	// ge[u擪|C^
			1024,						// X̎ge[u̓_
			8,							// ge[u̓_
			32768,						// X̃e[u̍őg
			32768						// ge[u̍őg
			);
		G13i_WFC_freq_table_ready = 1;
	}

	// -------------------------------------------------------------------------
	// -------------------------------------------------------------------------
	// ****		egf[^̑oƁCegobt@̏	****
	// -------------------------------------------------------------------------
	// -------------------------------------------------------------------------
	
	// TI, dataId								// 2013.05.23	T.Imachi
	ui_TI1 = *G13ui_EWO_TI1;					// 2013.05.23	T.Imachi
	uc_TI2 = *G13uc_EWO_TI2;					// 2013.05.23	T.Imachi
	i_packet_dataId = *G13uc_EWO_dataId;		// 2013.05.23	T.Imachi

	// XyNgԊu̕ω͐Ƀ`FbN
	i_int_chg = 0;
	if( uc_OFA_EB == Gd_EWO_OFA_E ){
		i_int_chg |= app13_EWO_OFA_param_check( &G13uc_WFC_OFA_E_interval_prev, G13uc_WFC_OFA_interval );	// OFA-E obs. interval
	}
	else{
		i_int_chg |= app13_EWO_OFA_param_check( &G13uc_WFC_OFA_B_interval_prev, G13uc_WFC_OFA_interval );	// OFA-B obs. interval
	}
	// L, M1, M2 ̃[v (i=0:L, 1:M1, 2:M2)
	for( i=0; i<3; i++ ){
		// -------------------------------------------------------------------------
		// ݒp[^̃`FbN
		// -------------------------------------------------------------------------
		
		// p[^ɕωꍇCi_flag ͂PƂȂD
		i_flag = i_int_chg;
		i_flag |= app13_EWO_OFA_param_check( &(*st_tlm_info[i]).uc_ofa_channel, uc_ofa_channel[i] );		// OFA Channel
		if( uc_OFA_EB == Gd_EWO_OFA_E){
			// 
			i_flag |= app13_EWO_OFA_param_check( &(*st_tlm_info[i]).uc_data_spec, G13uc_WFCE_input_select );
		}
		else{
			i_flag |= app13_EWO_OFA_param_check( &(*st_tlm_info[i]).uc_data_spec, 0x30 );
		}
		// AM2P check						// 2014.09.03 Imachi
		if( G14uc_AM2P_stage != 0 ) i_flag = 1;
		// p[^ɕωȂꍇ
		if( i_flag == 0 ){
			// L-mode : 8 XsƂɑo
			if( i == 0 && ( ui_sunpulseCnt & 0x07 ) != 0x00 ) continue;
		}
		// p[^ωꍇ
		else{
			// ge[u̍XV
			app13_EWO_freq_table_init(
				G13i_WFC_freq_table[i],			// ge[u擪|C^
				1024,							// X̎ge[u̓_
				G13i_WFC_freq_table_length[i],	// ge[u̓_
				32768,							// X̃e[u̍őg
				32768							// ge[u̍őg
				);
			// TLM packet info
			st_tlm_info[i]->i_n_spec_data = G13i_WFC_freq_table_length[i];
		}

		// -------------------------------------------------------------------------
		// egpPbgoƃobt@
		// -------------------------------------------------------------------------
		
		// OFA-L counter reset					// 2014.09.03 Imachi
		if( i == 0 ){
			if( uc_OFA_EB == Gd_EWO_OFA_E ){
				G13uc_OFA_E_L_count = -1;
			}
			else{
				G13uc_OFA_B_L_count = -1;
			}
		}

		// egpPbgłĂȂ΁CoȂ
		if( *uc_tlm_ready[i] < 1 ) continue;
		
		// egpPbgwb_
		//ui_TI1 = *G13ui_EWO_TI1;
		//uc_TI2 = *G13uc_EWO_TI2;
		//i_packet_dataId = *G13uc_EWO_dataId;
		
		// L
		if( i == 0 ){
			app13_EWO_OFA_make_tlm_header(
				st_tlm_info[0],
				st_tlm_info[0],
				G13ui_EWO_spin_period,
				uc_TI2,
				*i_tlm_size[0],
				uc_tlm_buf[0]
			);
			
			// ISDM
			if( uc_OFA_EB == Gd_EWO_OFA_E && G14uc_ISDM_tlm_size > 0 ){
				memcpy( &uc_tlm_buf[0][*i_tlm_size[0]], &G14uc_ISDM_tlm[0], G14uc_ISDM_tlm_size );
				*i_tlm_size[0] += G14uc_ISDM_tlm_size;
				G14uc_ISDM_tlm_size = 0;
			}
		}
		// M1
		else if( i == 1 ){
			app13_EWO_OFA_make_tlm_header(
				st_tlm_info[1],
				st_tlm_info[2],
				G13ui_EWO_spin_period,
				uc_TI2,
				*i_tlm_size[1],
				uc_tlm_buf[1]
			);
		}
		else continue;
		
		// H-dump flag
		if( Gui_TRG_TiStart < ui_TI1 + G13ui_EWO_spin_period * 2 &&
 				ui_TI1 - G13ui_EWO_spin_period * 5 < Gui_TRG_TiEnd )	uc_tlm_buf[i][3] |= 0x80;

		// egpPbgo
		if( ui_TI1 != 0 ){
			// ui = ui_TI1 + app_ti_spinRate( ui_TI1, Gd_N_EWO, &ui_spinCount ) + (ui_TI2 >> 4);		// TI correction - 1 spin-later + SunPulse delay
			app_PutTlm(
				13,							// [INPUT] APP-NUM: 13
				Gd_N_EWO,					// [INPUT] Node ID
				i_dataId,					// [INPUT] Data ID
				i_headId,					// [INPUT] Header ID (for PID-ID, CAT-ID settings)
				uc_tlm_bitrate[i],			// [INPUT] DR-ID (for CAT-ID) (0:HK, 1:OS, 2:L, 3:M, 4-9:H(0-5))
				Guc_TLMm_cmp[i_headId],		// *** rev 121125 by YK ***
				// 0,						// [INPUT] Comp mode (0:non, 1:JPEG-rev, 2:JPEG-nonrev, 3:After-User-Comp)
				i_packet_dataId,			// [INPUT] Packet ID (EWO pPbg̃f[^ID)
				ui_TI1,						// [INPUT] Data TI (擪f[^ Sun pulse )
				Guc_cmdDummy,				// [INPUT] Comment (Rg͎gpȂD_~[n)
				0,							// [INPUT] Comment size (Rg͎gpȂDO)
				uc_tlm_buf[i],				// [INPUT] Data (egf[^̃obt@)
				*i_tlm_size[i]				// [INPUT] Data sizeiegf[^̃TCYj
				);
		}
		// egobt@
		*i_tlm_size[i] = TLM_DATA_TOP;
		*uc_tlm_ready[i] = 0;
		*G13ui_EWO_TI1 = 0;
	}
	
	// -------------------------------------------------------------------------
	// -------------------------------------------------------------------------
	// ********		L/M f[^̐	********
	// -------------------------------------------------------------------------
	// -------------------------------------------------------------------------
	
	// -------------------------------------------------------------------------
	// ΏۃubNƂāCubN̂CŐV̂̂TD
	// iubNXVj
	// ubN΁CXVďID
	// -------------------------------------------------------------------------
	
	// ubN Buffer-ID ߂D
	// i_bufId ɂ Buffer-ID (0:Long, 1:Short, -1:no data) ԂD
	i_bufId = app_CheckNonProcBlock(
			Gd_N_EWO, i_dataId,			// [INPUT] Node/Data ID
			Gui_TLMm_blockTime[i_headId],	// [INPUT] TI of Processed Block
			&ui_timeData					// [OUTPUT] TI of Newest Block in the selected buffer
			);
	// i_bufId  no data ̏ꍇC͂ŏID
	if( i_bufId < 0 )
				return;
	
	// ubN߂D
	// i_numNewBlock ɃubNԂD̐Ԃꍇ̓f[^iG[j
	i_numNewBlock = app_SetNonProcBlock(
			Gd_N_EWO, i_dataId,				// [INPUT] Node/Data ID
			i_bufId,						// [INPUT] Buffer ID
			Gui_TLMm_blockTime[i_headId],	// [INPUT] IT of Processed Block
			&t_blockInfo						// [OUTPUT] Block info
			);
	// ubNꍇCi_bufId Ƌɋ߂ubN̍ŐVTIC
	// QƂ鏈ς݃ubNTIƂď㏑ďID
	if( i_numNewBlock < 1 ){
		if( uc_OFA_EB == Gd_EWO_OFA_B ) Gui_EWO_WFCB_blockTime = Gui_TLMm_blockTime[i_headId];
		Gui_TLMm_blockTime[i_headId] = ui_timeData;
		return;
	}

	// Ō̃ubN܂œǂݔ΂
	if( i_numNewBlock >= 2 ){
		i_lastProcBlock = i_numNewBlock - 2;
	}
	else{
		i_lastProcBlock = i_numNewBlock - 1;
	}
	for( i=0; i<i_lastProcBlock; i++ ){
		i_flag = app_NextBlock(
							Gd_N_EWO, i_dataId,	// [INPUT] Node/Data ID
							i_bufId,			// [INPUT] Buffer ID
							&t_blockInfo			// [OUTPUT] Block info
							);
	}
	// ubN̏`FbNďI
	if(		t_blockInfo.ui_createTime > Gui_TLMm_blockTime[i_headId] &&
			t_blockInfo.i_replyNum > 0 &&
			t_blockInfo.c_invalidFlg == 0	){
		if( uc_OFA_EB == Gd_EWO_OFA_B ) Gui_EWO_WFCB_blockTime = Gui_TLMm_blockTime[i_headId];
		Gui_TLMm_blockTime[i_headId] = t_blockInfo.ui_createTime;
	}
	else{
		if( uc_OFA_EB == Gd_EWO_OFA_B ) Gui_EWO_WFCB_blockTime = Gui_TLMm_blockTime[i_headId];
		Gui_TLMm_blockTime[i_headId] = ui_timeData;
		return;
	}
	
	// -------------------------------------------------------------------------
	// ΏۃubŃCŏ̂PpPbg̃wb_擾
	// ǂݏoɎsCID
	// -------------------------------------------------------------------------

	i_flag = app_GetPacket(
					13,						// [INPUT] App-No.: 13
					Gd_N_EWO, i_dataId,	// [INPUT] Node/Data ID
					i_bufId,				// [INPUT] Buffer ID
					&t_blockInfo,			// [INPUT] Block info
					0,						// [INPUT] Packet No. (0:擪)
					0,						// [INPUT] OFFSET ǂݏoJnԒn
					32,						// [INPUT] ǂݏof[^
					G13uc_data				// [OUTPUT] ǂݏof[^[obt@
					);
	if( i_flag != 0 )
				return;

	// DataID ̎擾
	// EWO-Header::DataID (EWO-Head::B6-7)
	i_packet_dataId = G13uc_data[22];
	// Date ID ̃`FbN
	if( uc_OFA_EB == Gd_EWO_OFA_E ){
		// EWO-E: G13uc_data  22-23  0000  0100 łȂ΁CG[ƂďI
		if ( ( G13uc_data[22] != 0x00 && G13uc_data[22] != 0x01) || G13uc_data[23] != 0 ) return;
		i_num_read = i_num_read_base;
	}
	else{
		// EWO-B: G13uc_data  22-23  3000  3100 łȂ΁CG[ƂďI
		if ( ( G13uc_data[22] != 0x30 && G13uc_data[22] != 0x31) || G13uc_data[23] != 0 ) return;
		// MF, LF ̃`FbN
		if( i_packet_dataId == 0x30 )		G13uc_WFCB_LF = 1;
		else						G13uc_WFCB_LF = 0;
		// LF ̏ꍇCǂݏof[^S{ɂD
		if( G13uc_WFCB_LF != 0 )	i_num_read = i_num_read_base * 4;
		else						i_num_read = i_num_read_base;
	}
	*G13uc_EWO_dataId = i_packet_dataId;
	
	// Sun pulse TI ̎擾
	// EWO-Head::B0-3: TI at SunPulse (LSB: 1.953ms)
	memcpy( &ui_TI1, &G13uc_data[16], 4 );
	// EWO-Head::B4-5: EWO counter (LSB: 122us)
	memcpy( &ui_TI2, &G13uc_data[20], 2 );
	uc_TI2 = G13uc_data[20];
	
	*G13ui_EWO_TI1 = ui_TI1;
	*G13us_EWO_TI2 = ui_TI2;
	*G13uc_EWO_TI2 = uc_TI2;
	
	// -------------------------------------------------------------------------
	// XsvZ
	// -------------------------------------------------------------------------

	// XsvZ (LSB: 1.953ms)
	if( uc_OFA_EB == Gd_EWO_OFA_E ){
		ui_spin_period = ui_TI1 - G13ui_EWOE_TI1_prev;
		G13ui_EWOE_TI1_prev = ui_TI1;
	}
	else{
		ui_spin_period = ui_TI1 - G13ui_EWOB_TI1_prev;
		G13ui_EWOB_TI1_prev = ui_TI1;
	}
	
	// XssȒl̏ꍇCXs 4.5 b (0x0900) ɉ
	if( ui_spin_period < 0x0800 || ui_spin_period > 0x0A00 ){
		ui_spin_period = 0x0900;
		f_spin_period = (double)ui_spin_period * 1.953 / 1000;
	}
	// XslƎvꍇAO[oϐɕۑ
	else{
		f_spin_period = (double)ui_spin_period * 1.953 / 1000;
		if( uc_OFA_EB == Gd_EWO_OFA_E ){
			G13f_EWOE_spin_period = (double)ui_spin_period * 1.953 / 1000;
			G13ui_EWO_spin_period = ui_spin_period;
		}
		else{
			G13f_EWOB_spin_period = (double)ui_spin_period * 1.953 / 1000;
			G13ui_EWO_spin_period = ui_spin_period;
		}
	}

	// -------------------------------------------------------------------------
	// ǂݏoEǂݔ΂pPbgvZ
	// -------------------------------------------------------------------------
	
	// 1 Xs̃pPbgvZiXs * TvOg / PpPbg̃f[^_j
	i_nPacket_1spin = f_spin_period * 65536 / 512;

	// pPbg̓ǂݔ΂ԊuvZ
	if( uc_OFA_EB == Gd_EWO_OFA_E && i_packet_dataId == 0x01 ){
		// EWO-E HF ̏ꍇAŒl
		i_num_skip = 80 * i_n_skip_base[G13uc_WFC_OFA_interval];
		i_num_offset = 100;
	}
	else{
		// ȊȌꍇA1/4  ~ 1/ϑ
		i_num_skip = ( i_nPacket_1spin / 4 ) * ( i_n_skip_base[G13uc_WFC_OFA_interval] );
		// 擪 1/8 spin (45deg) ǂݔ΂D
		i_num_offset = i_nPacket_1spin / 8;
	}
	i_num_skip -= i_num_read;

	
	// -------------------------------------------------------------------------
	// gXyNg𐶐
	// R[ɃegM
	// -------------------------------------------------------------------------

	// epPbg̏
	i_loop_count = -1;
	for( i = i_num_offset;
		 i < ( t_blockInfo.i_replyNum - i_num_read );
		 i += ( i_num_skip + i_num_read ) ){
		
		i_loop_count++;
		// WFC-E HF ̂݁A[v񐔂Œ
		if( uc_OFA_EB == Gd_EWO_OFA_E && i_packet_dataId == 0x01 ){
			if( i_loop_count >= i_n_loop[G13uc_WFC_OFA_interval] ){
				break;
			}
		}
		
		// EWO pPbgwb_̎擾
		i_flag = app_GetPacket(
						13,						// [INPUT] App-No.: 13
						Gd_N_EWO, i_dataId,		// [INPUT] Node/Data ID
						i_bufId,				// [INPUT] Buffer ID
						&t_blockInfo,			// [INPUT] Block info
						i,						// [INPUT] Packet No. (0:擪)
						0,						// [INPUT] OFFSET ǂݏoJnԒn
						32,						// [INPUT] ǂݏof[^
						G13uc_data				// [OUTPUT] ǂݏof[^[obt@
						);
		if( i_flag != 0 ) break;
		
		// DataID ̎擾
		// EWO-Header::DataID (EWO-Head::B6-7)
		i_packet_dataId = G13uc_data[22];
		// Date ID ̃`FbN
		if( uc_OFA_EB == Gd_EWO_OFA_E ){
			// EWO-E: G13uc_data  22-23  0000  0100 łȂ΁CG[ƂĎ
			if ( ( G13uc_data[22] != 0x00 && G13uc_data[22] != 0x01) || G13uc_data[23] != 0 ) continue;
			i_num_read = i_num_read_base;
		}
		else{
			// EWO-B: G13uc_data  22-23  3000  3100 łȂ΁CG[ƂĎ
			if ( ( G13uc_data[22] != 0x30 && G13uc_data[22] != 0x31) || G13uc_data[23] != 0 ) continue;
			// MF, LF ̃`FbN
			if( i_packet_dataId == 0x30 )		G13uc_WFCB_LF = 1;
			else						G13uc_WFCB_LF = 0;
			// LF ̏ꍇCǂݏof[^S{ɂD
			if( G13uc_WFCB_LF != 0 )	i_num_read = i_num_read_base * 4;
			else						i_num_read = i_num_read_base;

		}
		
		// Sun pulse TI ̎擾
		// EWO-Head::B0-3: TI at SunPulse (LSB: 1.953ms)
		// EWO-Head::B4-5: Time after SunPulse (LSB: 122us)
		memcpy( &ui_TI1, &G13uc_data[16], 4 );
		memcpy( &ui_TI2, &G13uc_data[20], 2 );
		uc_TI2 = ( G13uc_data[20] << 4 ) + ( G13uc_data[21] >> 4 );
		
		// DataSize ̎擾
		// EWO-Header::DataSize (EWO-Head::B8-9)
		i_dataSize = ( G13uc_data[24] << 8 ) + G13uc_data[25];
		
		// -------------------------------------------------------------------------
		// f[^pPbgǂݍ
		// -------------------------------------------------------------------------
		
		// pPbgŜ擾
		i_flag = app_GetPacket(
						13,								// [INPUT] App-No.: 13
						Gd_N_EWO, i_dataId,				// [INPUT] Node/Data ID
						i_bufId,						// [INPUT] Buffer ID
						&t_blockInfo,					// [INPUT] Block info
						i,								// [INPUT] Packet No. (0:擪)
						0,								// [INPUT] OFFSET ǂݏoJnԒn
						i_packet_size * i_num_read,		// [INPUT] ǂݏof[^
						G13uc_data						// [OUTPUT] ǂݏof[^[obt@
						);
		// ǂݏoς݃f[^_XV
		i_num_data = i_packet_size * i_num_read;
		
		// XyNg
		// L, M1, M2
		app13_EWO_OFA_make_spectrum(
			uc_OFA_EB,			// [INPUT] OFA-E or OFA-B
			G13uc_data,			// [INPUT] ̓f[^obt@i֐ŏ㏑ėpj
			i_num_data,			// [INPUT] ̓f[^̑傫iBytej
			uc_ofa_channel,		// [INPUT] L,M1,M2 ̃`li0:ABS,1:X,2:Y,3:Zj
			uc_tlm_buf,			// [INPUT/OUTPUT] egpPbgobt@
			i_tlm_size,			// [INPUT/OUTPUT] egpPbgobt@̃TCY
			uc_tlm_ready
			);
		// Dummy for break pointer
		i_num_data++;
		i_num_data--;
	}	// End of Loop (each packet)

	// Dummy for break pointer
	i_num_data++;
	i_num_data--;
	
	return;
}

/*******************************************************************************
	p[^l̍XV
--------------------------------------------------------------------------------
	Vlƌ݂̒lł΂OԂD
	قȂĂ΁CłPԂD
*******************************************************************************/
int app13_EWO_OFA_param_check(
	unsigned char *cur,		// [INPUT/OUTPUT] ݂̃p[^l
	unsigned char new		// [INPUT] Vp[^l
	){
	if( *cur == new ) return 0;
	else{
		*cur = new;
		return 1;
	}
}

/*******************************************************************************
	egpPbgwb_
*******************************************************************************/
/*
typedef struct {
	unsigned char	uc_data_spec;	// f[^敪
	unsigned char	uc_bitrate;		// rbg[g ( L:2, M:3 bH)
	unsigned char	uc_interval;	// f[^Ԋu
	unsigned char	uc_ofa_channel;	// OFA `l (0:ABS, 1:E1/Bx, 2:E2/By, 3:Bz)
	int				i_n_spec_data;	// XyNgf[^_
	unsigned char	uc_cal_on;		// CAL ON/OFF (0:OFF, 1:ON)
	unsigned char	uc_pre_gain;	// vAvQC
	unsigned char	uc_ofa_gain;	// OFA/WFC QC
} EWO_PACKET_INFO;
*/

void app13_EWO_OFA_make_tlm_header(
	EWO_PACKET_INFO	*st_tlm_info1,	// [INPUT] eg
	EWO_PACKET_INFO	*st_tlm_info2,	// [INPUT] eg
	unsigned int	ui_spinrate,	// [INPUT] Spin rate
	unsigned char	uc_TI2,			// [INPUT] EWO counter (reduced)
	int				i_size,			// [INPUT] egTCY
	unsigned char	*uc_buf			// [OUTPUT] egpPbgobt@
	){

	unsigned char	uc_ch_int, uc_gain;

	i_size -= TLM_DATA_TOP;
	
	// Channel & time interval
	uc_ch_int = 0x00;
	uc_ch_int |= ( 1 << st_tlm_info1->uc_ofa_channel );		// Channel 1
	uc_ch_int |= ( 1 << st_tlm_info2->uc_ofa_channel );		// Channel 2
	uc_ch_int |= ( ( st_tlm_info1->uc_interval & 0x03 ) << 4 );		// Time interval
	
	// Gain
	uc_gain = 0x00;
	uc_gain |= ( ( st_tlm_info1->uc_pre_gain & 0x01 ) << 2 );
	uc_gain |= ( ( st_tlm_info1->uc_ofa_gain & 0x03 ) );

	// =======================================================================

	// B0:	EWO counter
	uc_buf[0] = uc_TI2;
	// B1-B2:	Spin rate
	uc_buf[1] = (unsigned char)( ( ui_spinrate >> 8 ) & 0xff );
	uc_buf[2] = (unsigned char)( ui_spinrate & 0xff );
	// B3:	OFA channel & time inteval
	uc_buf[3] = uc_ch_int;
	// B4:	Gain
	uc_buf[4] = uc_gain;
	// B5:	Spec
	uc_buf[5] = st_tlm_info1->uc_data_spec;
	// B6-B7:	Spectrum length
	uc_buf[6] = (unsigned char)( st_tlm_info1->i_n_spec_data >> 8 );
	uc_buf[7] = (unsigned char)( st_tlm_info1->i_n_spec_data &0xff );
	// B8-B9:	Data size
	uc_buf[8] = (unsigned char)( ( i_size >> 8 ) & 0xff );
	uc_buf[9] = (unsigned char)( i_size & 0xff );
}


/*******************************************************************************
	XyNg
*******************************************************************************/
void app13_EWO_OFA_make_spectrum(
		unsigned char	uc_OFA_EB,			// [INPUT] OFA-E or OFA-B
		unsigned char	*uc_data,			// [INPUT] ̓f[^obt@i֐ŏ㏑ėpj
		unsigned int	ui_data_size,		// [INPUT] ̓f[^̑傫iBytej
		unsigned char	*uc_ofa_channel,	// [INPUT] L,M1,M2 ̃`li0:ABS,1:X,2:Y,3:Zj
		unsigned char	**uc_tlm_buf,		// [INPUT/OUTPUT] egpPbgobt@
		int				**i_tlm_size,		// [INPUT/OUTPUT] egpPbgobt@̃TCY
		unsigned char	**uc_tlm_ready		// [OUTPUT] Telemtry packet ready
	){

	int		i_nPacket;		// pPbg
	int		i_packetSize;	// pPbgTCY
	int		i_nRead;		// PpPbgӂ̃f[^ǂݏo_
	int		i_ch;			// `l
	
	int		i_count;		// ǂݏoς݃f[^̃JEg
	int		i_pos_read;		// pPbgf[^ǂݏoʒu
	int		i_dataX;
	int		i_dataY;
	int		i_dataZ;
	
	int		i_nFFT;			// FFT _
	
	int		*i_X_max, *i_Y_max, *i_Z_max, i_dummy;		// for AGC
	
	int		i, j;
	
	// -------------------------------------------------------------------------
	// ݒ
	// -------------------------------------------------------------------------
	
	i_nFFT = 2048;
	
	if( uc_OFA_EB == Gd_EWO_OFA_E ){
		i_packetSize = Gd_Pac_EWOE;
		i_ch = 2;
		i_nRead = 512;
		// for AGC
		i_X_max = &G13i_EWO_WFCE_X_max;
		i_Y_max = &G13i_EWO_WFCE_Y_max;
		i_Z_max = &i_dummy;
		*i_Z_max = 0;
	}
	else{
		i_packetSize = Gd_Pac_EWOB;
		i_ch = 3;
		// WFC-B LF́CPpPbg̃f[^_ 1/4 ƂD
		// i擪 1/4 ǂ܂Ȃj
		if( G13uc_WFCB_LF == 0 )	i_nRead = 512;
		else						i_nRead = 512 / 4;
		// for AGC
		i_X_max = &G13i_EWO_WFCB_X_max;
		i_Y_max = &G13i_EWO_WFCB_Y_max;
		i_Z_max = &G13i_EWO_WFCB_Z_max;

	}
	
	// -------------------------------------------------------------------------
	// f[^ǂݏoidEQ͎ERj
	// -------------------------------------------------------------------------

	i_nPacket = ui_data_size / i_packetSize;
	i_count = 0;
	// pPbg̐[v
	for( i=0; i<i_nPacket; i++ ){
		// PpPbg̃f[^_i512_j[v
		for( j=0; j<i_nRead; j++ ){
			// pPbg̃f[^ǂݍ݈ʒu
			// i`l~QoCgD擪 26 oCg͓ǂݔ΂j
			i_pos_read = i_packetSize * i + 26 + ( j * i_ch * 2 );
			// AQoCgCPf[^ƂĎ[
			i_dataX = (int)( uc_data[i_pos_read + 0] << 8 ) + (int)uc_data[i_pos_read + 1];
			i_dataY = (int)( uc_data[i_pos_read + 2] << 8 ) + (int)uc_data[i_pos_read + 3];
			if( uc_OFA_EB == Gd_EWO_OFA_B ){
				i_dataZ = (int)( uc_data[i_pos_read + 4] << 8 ) + (int)uc_data[i_pos_read + 5];
			}
			else{
				i_dataZ = 0;	// 
			}
			// unsigned  signed ɕϊ
			// AGC pőrbgZołȂ
			if( i_dataX >= 32768 ){
				i_dataX -= 65536;
				*i_X_max |= i_dataX * ( -1 );
			}
			else *i_X_max |= i_dataX;
			
			if( i_dataY >= 32768 ){
				i_dataY -= 65536;
				*i_Y_max |= i_dataY * ( -1 );
			}
			else *i_Y_max |= i_dataY;
				
			if( i_dataZ >= 32768 ){
				i_dataZ -= 65536;
				*i_Z_max |= i_dataZ * ( -1 );
			}
			else *i_Z_max |= i_dataZ;
				
			// _obt@ɔg`̂܂ܕۑ
			G13f_WFC_X_org[i_count] = (double)i_dataX;
			G13f_WFC_Y_org[i_count] = (double)i_dataY;
			G13f_WFC_Z_org[i_count] = (double)i_dataZ;
			i_count++;
		}
	}
	
/*
	// -------------------------------------------------------------------------
	// IIIeXgp[MIII
	// -------------------------------------------------------------------------
	for( i=0; i<i_nFFT; i++ ){
		G13f_WFC_X_org[i] = 4096.0 * app_math_cos( 3.1415926536 * 2 / 65536 * 1000 * (double)i );
		G13f_WFC_Y_org[i] = 4096.0 * app_math_cos( 3.1415926536 * 2 / 65536 * 1000 * (double)i );
		G13f_WFC_Z_org[i] = 4096.0 * app_math_cos( 3.1415926536 * 2 / 65536 * 1000 * (double)i );
	}
*/
	
	// -------------------------------------------------------------------------
	// FFTiCׂĂ̐ 2048 _ FFTj
	// -------------------------------------------------------------------------

	// ֐Kp				// 2012.11.21	T.imachi
	app_EWO_Hamming2( G13f_WFC_X_org, G13f_WFC_X_org, i_nFFT );
	app_EWO_Hamming2( G13f_WFC_Y_org, G13f_WFC_Y_org, i_nFFT );
	app_EWO_Hamming2( G13f_WFC_Z_org, G13f_WFC_Z_org, i_nFFT );

	// E1, E2  Bx, By 𓯎 FFT
	app_EWO_rfft_dual(
			i_nFFT,
			G13f_WFC_X_org, G13f_WFC_X_spec_re, G13f_WFC_X_spec_im,
			G13f_WFC_Y_org, G13f_WFC_Y_spec_re, G13f_WFC_Y_spec_im
			);
	// ȄꍇCBz P FFT
	if( uc_OFA_EB == Gd_EWO_OFA_B ){
		app_EWO_rfft( G13f_WFC_Z_org, i_nFFT, G13f_WFC_Z_spec_re, G13f_WFC_Z_spec_im );
	}

	// -------------------------------------------------------------------------
	// g (L, M1, M2) ƃegobt@ւ̎[
	// -------------------------------------------------------------------------

	// L, M1, M2 ̃[v (i=0:L, 1:M1, 2:M2)
	for( i=0; i<3; i++ ){
		// L ɂẮCQɂPs
		if( i == 0 ){
			if( uc_OFA_EB == Gd_EWO_OFA_E ){
				G13uc_OFA_E_L_count++;
				if( G13uc_OFA_E_L_count != 0 ){
					G13uc_OFA_E_L_count = -1;
					continue;
				}
			}
			else{
				G13uc_OFA_B_L_count++;
				if( G13uc_OFA_B_L_count != 0 ){
					G13uc_OFA_B_L_count = -1;
					continue;
				}
			}
		}
		// X gρi`lOP̂Ƃj
		if( uc_ofa_channel[i] == 0 || uc_ofa_channel[i] == 1 ){
			app13_EWO_spectrum_reduce(
				G13f_WFC_spec_ave[0],	// [OUTPUT] f[^o̓obt@
				G13f_WFC_X_spec_re,	// [INPUT] XyNg̔z
				G13f_WFC_X_spec_im,	// [INPUT] XyNg̔z
				i_nFFT / 2,					// [INPUT] XyNg_
				G13i_WFC_freq_table[i],		// [INPUT] ωge[u
				G13i_WFC_freq_table_length[i]	// [INPUT] ωge[u
				);
		}
		// Y gρi`lOQ̂Ƃj
		if( uc_ofa_channel[i] == 0 || uc_ofa_channel[i] == 2 ){
			app13_EWO_spectrum_reduce(
				G13f_WFC_spec_ave[1],	// [OUTPUT] f[^o̓obt@
				G13f_WFC_Y_spec_re,	// [INPUT] XyNg̔z
				G13f_WFC_Y_spec_im,	// [INPUT] XyNg̔z
				i_nFFT / 2,					// [INPUT] XyNg_
				G13i_WFC_freq_table[i],		// [INPUT] ωge[u
				G13i_WFC_freq_table_length[i]	// [INPUT] ωge[u
				);
		}
		// Z gρiŃ`lOR̂Ƃj
		if( uc_OFA_EB == Gd_EWO_OFA_B && ( uc_ofa_channel[i] == 0 || uc_ofa_channel[i] == 3 ) ){
			app13_EWO_spectrum_reduce(
				G13f_WFC_spec_ave[2],	// [OUTPUT] f[^o̓obt@
				G13f_WFC_Z_spec_re,		// [INPUT] XyNg̔z
				G13f_WFC_Z_spec_im,		// [INPUT] XyNg̔z
				i_nFFT / 2,					// [INPUT] XyNg_
				G13i_WFC_freq_table[i],		// [INPUT] ωge[u
				G13i_WFC_freq_table_length[i]	// [INPUT] ωge[u
				);
		}
		
		// egpPbgobt@Ɏ[
		if( uc_ofa_channel[i] == 0 ){
			//
			// Βli`lÔƂj
			//
			// S̓lv
			if( uc_OFA_EB == Gd_EWO_OFA_E ){
				for( j = 0; j<G13i_WFC_freq_table_length[i]; j++ ){
					G13f_WFC_spec_abs[j] =
						G13f_WFC_spec_ave[0][j] + G13f_WFC_spec_ave[1][j];
				}
			}
			else{
				for( j = 0; j<G13i_WFC_freq_table_length[i]; j++ ){
					G13f_WFC_spec_abs[j] =
						G13f_WFC_spec_ave[0][j] + G13f_WFC_spec_ave[1][j] + G13f_WFC_spec_ave[2][j];
				}
			}
			// XyNgf[^ dB 
			// [́CG13uc_data ėp
			app13_EWO_spectrum_dB(
				G13uc_data,					// [OUTPUT] o͐obt@
				G13f_WFC_spec_abs,			// [INPUT] f[^iXyNgPx̓lj
				G13i_WFC_freq_table_length[i],		// [INPUT] f[^̐
				i_nFFT						// [INPUT] ZliFFT_j
				);
		}
		else if( ( uc_ofa_channel[i] > 0 && uc_ofa_channel[i] <= 2 ) 
					|| ( uc_ofa_channel[i] == 3 && uc_OFA_EB == Gd_EWO_OFA_B ) ){
			//
			// ΒlȊOi`lP`R̂Ƃj
			//
			// XyNgf[^ dB 
			// [́CG13uc_data ėp
			app13_EWO_spectrum_dB(
				G13uc_data,									// [OUTPUT] o͐obt@
				G13f_WFC_spec_ave[uc_ofa_channel[i]-1],		// [INPUT] f[^iXyNgPx̓lj
				G13i_WFC_freq_table_length[i],				// [INPUT] f[^̐
				i_nFFT										// [INPUT] ZliFFT_j
				);
		}
		// egobt@Ɏ[
		// L-mode
		if( i==0 ){
			memcpy( &uc_tlm_buf[0][*i_tlm_size[0]], G13uc_data, G13i_WFC_freq_table_length[0] );
			*i_tlm_size[0] += G13i_WFC_freq_table_length[0];
		}
		// M-mode
		else{
			memcpy( &uc_tlm_buf[1][*i_tlm_size[1]], G13uc_data, G13i_WFC_freq_table_length[i] );
			*i_tlm_size[1] += G13i_WFC_freq_table_length[i];
		}
		*uc_tlm_ready[i] = 1;
	}	// Loop end ( L, M1, M2 ̃[v (i=0:L, 1:M1, 2:M2) )
	
	// -------------------------------------------------------------------------
	// TRGϐւ̑
	// -------------------------------------------------------------------------

	// Gui_TRG2_SpTI_s  TI 
	/* ***** COMMENT-OUT *****											// ***** rev. 121125 by Y.K. ****
	for( i=0; i<Gd_TRG_MAX; i++ ){
		if( Gui_TRG2_SpTI_s[i] <= *G13ui_EWO_TI1 )	break;
	}
	// Guc_TRG2_EWO_?sp Yvfɑ
	if( i < Gd_TRG_MAX && i > 0 ){
	*/
	i = app_tiTrgSearch( *G13ui_EWO_TI1, Gd_N_EWO );					// ***** added!  121125 by Y.K. ****
	if (i) {															// ***** added!  121125 by Y.K. ****
		// g
		app13_EWO_spectrum_reduce(
			G13f_WFC_spec_ave[0],		// [OUTPUT] f[^o̓obt@
			G13f_WFC_X_spec_re,			// [INPUT] XyNg̔z
			G13f_WFC_X_spec_im,			// [INPUT] XyNg̔z
			i_nFFT / 2,					// [INPUT] XyNg_
			G13i_WFC_freq_table_TRG,	// [INPUT] ωge[u
			8							// [INPUT] ωge[u
			);
		app13_EWO_spectrum_reduce(
			G13f_WFC_spec_ave[1],		// [OUTPUT] f[^o̓obt@
			G13f_WFC_Y_spec_re,			// [INPUT] XyNg̔z
			G13f_WFC_Y_spec_im,			// [INPUT] XyNg̔z
			i_nFFT / 2,					// [INPUT] XyNg_
			G13i_WFC_freq_table_TRG,	// [INPUT] ωge[u
			8							// [INPUT] ωge[u
			);
		if( uc_OFA_EB == Gd_EWO_OFA_B ){
			app13_EWO_spectrum_reduce(
				G13f_WFC_spec_ave[2],		// [OUTPUT] f[^o̓obt@
				G13f_WFC_Z_spec_re,			// [INPUT] XyNg̔z
				G13f_WFC_Z_spec_im,			// [INPUT] XyNg̔z
				i_nFFT / 2,					// [INPUT] XyNg_
				G13i_WFC_freq_table_TRG,	// [INPUT] ωge[u
				8							// [INPUT] ωge[u
				);
		}
		// Βl TRG ϐɑ
		if( uc_OFA_EB == Gd_EWO_OFA_E ){
			// ΒlvZ
			for( j = 0; j<8; j++ ){
				G13f_WFC_spec_abs[j] =
					G13f_WFC_spec_ave[0][j] + G13f_WFC_spec_ave[1][j];
			}
			// TRG ϐ֑
			app13_EWO_spectrum_dB(
				&Guc_TRG2_EWO_Esp[ i - 1 ][0],	// [OUTPUT] o͐obt@
				G13f_WFC_spec_abs,				// [INPUT] f[^iXyNgPx̓lj
				8,								// [INPUT] f[^̐
				i_nFFT							// [INPUT] ZliFFT_j
				);
			// Unsigned range ɂ邽߁A+0x80
			for( j=0; j<8; j++ ){
				Guc_TRG2_EWO_Esp[ i - 1 ][j] = (unsigned char)( (char)Guc_TRG2_EWO_Esp[ i - 1 ][j] + 0x80 );
			}
		}
		else{
			// ΒlvZ
			for( j = 0; j<8; j++ ){
				G13f_WFC_spec_abs[j] =
					G13f_WFC_spec_ave[0][j] + G13f_WFC_spec_ave[1][j] + G13f_WFC_spec_ave[2][j];
			}
			// TRG ϐ֑
			app13_EWO_spectrum_dB(
				&Guc_TRG2_EWO_Bsp[ i - 1 ][0],	// [OUTPUT] o͐obt@
				G13f_WFC_spec_abs,				// [INPUT] f[^iXyNgPx̓lj
				8,								// [INPUT] f[^̐
				i_nFFT							// [INPUT] ZliFFT_j
				);
			// Unsigned range ɂ邽߁A+0x80
			for( j=0; j<8; j++ ){
				Guc_TRG2_EWO_Bsp[ i - 1 ][j] = (unsigned char)( (char)Guc_TRG2_EWO_Bsp[ i - 1 ][j] + 0x80 );
			}
		}
	}
}


/*******************************************************************************
	XyNg_k
*******************************************************************************/
void app13_EWO_spectrum_reduce(
	double		*f_buf,					// [OUTPUT] f[^o̓obt@
	double		*f_re,					// [INPUT] XyNg̔z
	double		*f_im,					// [INPUT] XyNg̔z
	int			i_data_length,			// [INPUT] XyNg_
	int			*i_freq_table,			// [INPUT] ωge[u
	int			i_freq_table_length		// [INPUT] ωge[u
	)
{
	int 			i_freq_from, i_freq_to;
//	int				i_freq_prev;
//	double 			f_freq_diff;
	double			f_tmp;
	double			*f_wp;
	int				i, j;
	
	// f[^̏ݐw
	f_wp = f_buf;

//	i_freq_prev = 0;

	// ge[u̗vfɏ
	//		ge[u̗vfF FFT ̎gԍ
//	for( i=0; i<i_freq_table_length-1; i++ ){
	for( i=0; i<i_freq_table_length; i++ ){
		// Ώ۔͈
		i_freq_from = i_freq_table[i];
		i_freq_to = i_freq_table[i+1];
		
		// Ώ۔͈͂̕ϒlvZ
		f_tmp = 0;
		for( j=i_freq_from; j<i_freq_to; j++ ){
			f_tmp += f_re[j]*f_re[j] + f_im[j]*f_im[j];
		}
		
		// ʂzɎ[
		*f_wp++ = f_tmp;

		/*
		// Ώ۔͈
		i_freq = i_freq_table[i];
		f_freq_diff = (double)( i_freq - i_freq_prev );
		
		// Ώ۔͈͂̕ϒlvZ
		f_tmp = 0;
		
		for( j=0; j<f_freq_diff; j++ ){
			f_tmp += f_re[i_freq + j]*f_re[i_freq + j] + f_im[i_freq + j]*f_im[i_freq + j];
		}
		// f_tmp /= ( f_freq_diff * f_freq_diff );	// Ƃ肠Cf[^_ł͊Ȃ
		
		// ʂzɎ[
		*f_wp++ = f_tmp;
		// *f_wp++ = i;
		
		i_freq_prev = i_freq;
		*/
	}
	
	return;
}

/*******************************************************************************
	XyNg dB 
*******************************************************************************/
void app13_EWO_spectrum_dB(
	unsigned char	*uc_buf,		// [OUTPUT] o͐obt@
	double			*f_data,		// [INPUT] f[^iXyNgPx̓lj
	int				i_num_data,		// [INPUT] f[^̐
	int				i_div			// [INPUT] Zl
	)
{
	double			f_offset;
	unsigned char	*uc_wp;
	double			f_tmp;
	int		i;
	
	// Zl̏pΐ
	//		FFT ɐU 1/2 ɂȂĂ̂ŁA̕l
	f_offset = app_math_log10( (double)( i_div / 2 ) );
	// lCQ{ĂijAł̓摊j
	f_offset *= 2;
	
	uc_wp = uc_buf;
	for( i=0; i<i_num_data; i++ ){
		// f[^l̏pΐ
		f_tmp = app_math_log10( f_data[i] );
		// ZlijAł̏Zj
		f_tmp -= f_offset;
		// dB D̂߁C~10
		f_tmp *= 10;
		// _Ci~bNW
		f_tmp = f_tmp * 2 - 80;
		if( f_tmp > 127 ) f_tmp = 127;
		if( f_tmp < -128 ) f_tmp = -128;
		// o̓obt@Ɏ[
		// iunsigned char ɃLXgĂC͕ێj
		*uc_wp++ = (unsigned char)( f_tmp );
		//*uc_wp++ = f_data[i];
	}
	
	return;
}


/*******************************************************************************
	ge[u
*******************************************************************************/
void app13_EWO_freq_table_init(
	int		*i_freq_table,		// ge[u擪|C^
	int		i_table_size_org,	// X̎ge[u̓_
	int		i_table_size_out,	// ge[u̓_
	double	f_fmax_org,			// X̃e[u̍őg
	double	f_fmax_out			// ge[u̍őg
	)
{
	double	f_df;
	double	f_a, f_b, f_c;
	int		i_n1, i_n2;
	int		i;
	
	// g\vZ
	f_df = f_fmax_org / (double)i_table_size_org;
	
//	for( i=0; i<i_table_size_out; i++ ){
	for( i=0; i<=i_table_size_out; i++ ){
		// ΐIe[ǔvZ
//		f_a = (double)i / (double)( i_table_size_out - 1 );
		f_a = (double)i / (double)( i_table_size_out );
		f_b = f_fmax_out / f_df;
		f_c = app_math_pow( 10, f_a * app_math_log10( f_b ) );
		i_n2 = (int)f_c;
		// `Ie[ǔvZ
		i_n1 = i + 1;
		// rđ傫̗p
		if( i_n1 >= i_n2 ){
			i_freq_table[i] = i_n1 - 1;
		}
		else{
			i_freq_table[i] = i_n2 - 1;
		}
	}
}


/*******************************************************************************
	AGC
*******************************************************************************/

void app13_EWO_AGC(
	unsigned int	ui_sunpulseCnt,
	unsigned char	uc_OFA_EB
	)
{
	unsigned char	uc_AGC_ena;
	int				i_max;
	
	if( uc_OFA_EB == Gd_EWO_OFA_E ){
		uc_AGC_ena = G13uc_EWOE_AGC_ena;
		i_max = G13i_EWO_WFCE_X_max | G13i_EWO_WFCE_Y_max;
	}
	else{
		uc_AGC_ena = G13uc_EWOB_AGC_ena;
		i_max = G13i_EWO_WFCB_X_max | G13i_EWO_WFCB_Y_max | G13i_EWO_WFCB_Z_max;
	}
	
	// AGC enabled ̏ꍇ
	if( uc_AGC_ena != 0 ){
		// AGCs^C~OłȂΏI
		if( ( ui_sunpulseCnt & G13uc_EWO_AGC_interval ) != 0x00  ) return;
		
		if( uc_OFA_EB == Gd_EWO_OFA_E ){
			// QCAbv
			if( i_max < G13i_EWO_WFCE_lower_limit ){
				G13c_EWO_WFCE_AGC_act = 1;
			}
			// QC_E
			if( i_max > G13i_EWO_WFCE_upper_limit ){
				G13c_EWO_WFCE_AGC_act = -1;
			}
		}
		else{
			// QCAbv
			if( i_max < G13i_EWO_WFCB_lower_limit ){
				G13c_EWO_WFCB_AGC_act = 1;
			}
			// QC_E
			if( i_max > G13i_EWO_WFCB_upper_limit ){
				G13c_EWO_WFCB_AGC_act = -1;
			}
		}
	}
	
	// ōrbgl
	// 	(AGC disabled ̏ꍇƁAAGC enabled  AGC s^C~Ȍꍇ)s
	if( uc_OFA_EB == Gd_EWO_OFA_E ){
		G13i_EWO_WFCE_X_max = 0;
		G13i_EWO_WFCE_Y_max = 0;
	}
	else{
		G13i_EWO_WFCB_X_max = 0;
		G13i_EWO_WFCB_Y_max = 0;
		G13i_EWO_WFCB_Z_max = 0;
	}
}

/*******************************************************************************
	ISDM table dump
*******************************************************************************/
void app13_EWO_ISDM_table_dump()
{
	unsigned int		ui_TI;
	M_T_TIME_INFO		t_timeInfo;
	
	if( G14uc_ISDM_table_dump_ena == 0 )
		return;
	
	dpu_getTime(&t_timeInfo);
	ui_TI = (t_timeInfo.ui_currentTime);	// unsigned int ui_currentTime;  q(1LSB=1.953ms)
				
	// B0:	N/A (EWO counter)
	G13uc_data[0] = 0x00;
	// B1-B2:	N/A (Spin rate)
	G13uc_data[1] = 0x00;
	G13uc_data[2] = 0x00;
	// B3:	N/A (OFA channel & time inteval)
	G13uc_data[3] = 0x00;
	// B4:	N/A (Gain)
	G13uc_data[4] = 0x00;
	// B5:	Spec
	G13uc_data[5] = 0xdd;
	/*
	// B6-B7:	Spectrum length
	G13uc_data[6] = (unsigned char)( st_tlm_info1->i_n_spec_data >> 8 );
	G13uc_data[7] = (unsigned char)( st_tlm_info1->i_n_spec_data &0xff );
	// B8-B9:	Data size
	G13uc_data[8] = (unsigned char)( ( i_size >> 8 ) & 0xff );
	G13uc_data[9] = (unsigned char)( i_size & 0xff );
	*/
	
	memcpy( &G13uc_data[6], &G14uc_ISDM_table[0], 74 );
	
	app_PutTlm(
			13,							// [INPUT] APP-NUM: 13
			Gd_N_EWO,					// [INPUT] Node ID
			Gd_D_EWOE,					// [INPUT] Data ID
			Gd_N_EWOE,					// [INPUT] Header ID (for PID-ID, CAT-ID settings)
			0x02,						// [INPUT] DR-ID (for CAT-ID) (0:HK, 1:OS, 2:L, 3:M, 4-9:H(0-5))
			Guc_TLMm_cmp[Gd_N_EWOE],	// *** rev 121125 by YK ***
			// 0,						// [INPUT] Comp mode (0:non, 1:JPEG-rev, 2:JPEG-nonrev, 3:After-User-Comp)
			0x00,						// [INPUT] Packet ID (EWO pPbg̃f[^ID)
			ui_TI,						// [INPUT] Data TI (擪f[^ Sun pulse )
			Guc_cmdDummy,				// [INPUT] Comment (Rg͎gpȂD_~[n)
			0,							// [INPUT] Comment size (Rg͎gpȂDO)
			G13uc_data,					// [INPUT] Data (egf[^̃obt@)
			80							// [INPUT] Data sizeiegf[^̃TCYj
			);
	
	G14uc_ISDM_table_dump_ena = 0;
}

/* ***************************************************************************
[MEMO]
------------------------------------------------------------------------------

XyNg

	[INPUT]	( E1, E2 ) or ( Bx, By, Bz )
		
	CS FFTi\ȌCQj
	( E1_re, E1_im, E2_re, E2_im ) or ( Bx_re, Bx_im, By_re, By_im, Bz_re, Bz_im )
		
	CCSXyNg֐
		
	XyNg
		eiQjF	re^2 + im^2
		ΒliQjF	( re^2 + im^2 )
		
	XyNg
		Q̂܂ܕ
		
	DB
		Qz
		f[^_{z
		
	 _Ci~bNW
		́F	Signed 14bit = -8192 ` +8192
				 ` 78.27dB
		 char  -128 ` +127 ɃtBbgD
			ϕlCɂ 20 dB ȏ̗]TD
			͂̉ -20dB xD
				IWiF	-20 ` +78.27
				ϊ@F	* 2 - 80
				ϊF	-120 ` +76.54

------------------------------------------------------------------------------

TI
	TI1:	Sun pulse TI	LSB: 1.953 ms
	TI2:	EWO counter		LSB: 122 us
	
	TI1 / TI2 = 16
	
	TI2  1.923ms \ = TI2 >> 4
	
	OFA L/M ł́C1.953 ms \lvZC32 ms \ŉ낷D
		( ( TI1 + ( TI2 >> 4 ) ) >> 4 ) & 0xffff;
		
	TI1:	7======07======07======07======0
	TI2:	                    7======07======0
	TLM:	            ################
------------------------------------------------------------------------------

egpPbg

	00-03	Sun pulse TI (1.953 ms)
	04		EWO count (122us)

*************************************************************************** */
