/*******************************************************************************
*   W[      FAPP EWO Common - Decimation filter                   *
*   W[x    Fapp_EWO_PIs                                          *
*   ^XN敪          FApplication  EWO Common task                         *
*   @\                F                                                     *
*   R[OV[PXFvoid app_EWO_(PI)                                    *
*                   FȂ                                                 *
*   ߂l              FȂ                                                 *
*   gp̒        FO[oϐ̓AvP[VOPł܂Ƃ߂ď *
*   G[          FȂ                                                 *
*   				F  EDIT́AEWOg                                  *
*   쐬E쐬      F2012/09/19    Y.Kasaba                               *
*******************************************************************************/
#include "app_common.h"
#include "app_EWO.h"

// ******************
// *** Macro: local
// ******************
int app_EWO_decimation		(	double *f_data,	int	i_data_num,	double *f_work, int	i_down_sample_rate,	double *f_h,	int	i_filter_num );


// ******************************************************************************************************************
// EWO: Decimation Fiters --- 1/2 decimation filter with down sampling
// ------------------------------------------------------------------------------------------------------------------
//	int app_EWO_decimation_2(	double 	*f_data,				//	[IN/OUT]	g`ѕϊ̔g`
//								int	 	i_data_num,				//	[INPUT]		g`̃f[^_			[MAX: 8192]
//								double	*f_work,				//  [INPUT]		[NGA̐擪|C^
//								int 	i_down_sample_rate )	//	[INPUT]		_ETvO[g (1:_ETvȂ)
//																//	߂lF	ϊ̃f[^_D
//																//				  	_ETv:     i_data_num-(tB^W̐[31])/2
//																//					_ETvO: L / i_down_sample_rate
//																//	FilterW	31
// ******************************************************************************************************************
/*		---- comment out	2012.09.19 Kasaba
int 	app_EWO_decimation_2(	double 	*f_data,				//	[IN/OUT]	g`ѕϊ̔g`
								int	 	i_data_num,				//	[INPUT]		g`̃f[^_			[MAX: 8192]
								double	*f_work,				//  [INPUT]		[NGA̐擪|C^
								int 	i_down_sample_rate )	//	[INPUT]		_ETvO[g (1:_ETvȂ)
																//	߂lF	ϊ̃f[^_D
																//				  	_ETv:     i_data_num-(tB^W̐[31])/2
																//					_ETvO: L / i_down_sample_rate
																//	FilterW	31
{
  	return app_EWO_decimation( 	f_data, 						// [IN/OUT]	Data -> ϊData
  								i_data_num,						// [INPUT]	Data̓_
 								f_work,							// [INPUT]		[NGA̐擪|C^
 								i_down_sample_rate, 			// [INPUT]	Down-sampling rate
  								Gf_EWO_DEC_h2, 					// [INPUT]	FilterW 		[31]		(defined in 'app_EWO_variable.c')
  								31 );							// [INPUT]	Filter Number	[31]
																//	߂lFϊ̃f[^_D
}
*/


// tB^Wǌ^	2012.08.07 Imachi
int 	app_EWO_decimation_2_2(	double 	*f_data,				//	[IN/OUT]	g`ѕϊ̔g`
								int	 	i_data_num,				//	[INPUT]		g`̃f[^_			[MAX: 8192]
								double	*f_work,				//  [INPUT]		[NGA̐擪|C^
								int 	i_down_sample_rate )	//	[INPUT]		_ETvO[g (1:_ETvȂ)
																//	߂lF	ϊ̃f[^_D
																//				  	_ETv:     i_data_num-(tB^W̐[31])/2
																//					_ETvO: L / i_down_sample_rate
																//	FilterW	31
{
  	return app_EWO_decimation( 	f_data, 						// [IN/OUT]	Data -> ϊData
  								i_data_num,						// [INPUT]	Data̓_
 								f_work,							// [INPUT]		[NGA̐擪|C^
 								i_down_sample_rate, 			// [INPUT]	Down-sampling rate
  								Gf_EWO_DEC_h2_2, 				// [INPUT]	FilterW 		[31]		(defined in 'app_EWO_variable.c')
  								25 );							// [INPUT]	Filter Number	[31]
																//	߂lFϊ̃f[^_D
}

// EFD p	2012.08.22 Imachi
int 	app_EWO_decimation_2_efd(	double 	*f_data,				//	[IN/OUT]	g`ѕϊ̔g`
								int	 	i_data_num,				//	[INPUT]		g`̃f[^_			[MAX: 8192]
								double	*f_work,				//  [INPUT]		[NGA̐擪|C^
								int 	i_down_sample_rate )	//	[INPUT]		_ETvO[g (1:_ETvȂ)
																//	߂lF	ϊ̃f[^_D
																//				  	_ETv:     i_data_num-(tB^W̐[31])/2
																//					_ETvO: L / i_down_sample_rate
																//	FilterW	31
{
  	return app_EWO_decimation( 	f_data, 						// [IN/OUT]	Data -> ϊData
  								i_data_num,						// [INPUT]	Data̓_
 								f_work,							// [INPUT]		[NGA̐擪|C^
 								i_down_sample_rate, 			// [INPUT]	Down-sampling rate
  								Gf_EWO_DEC_h2_efd, 				// [INPUT]	FilterW 		[31]		(defined in 'app_EWO_variable.c')
  								27 );							// [INPUT]	Filter Number	[31]
																//	߂lFϊ̃f[^_D
}

// ******************************************************************************************************************
// EWO: Decimation Fiters --- 1/32 decimation filter with down sampling
// ------------------------------------------------------------------------------------------------------------------
// int 	app_EWO_decimation_32(	double	*f_data,				//	[IN/OUT]	g`ѕϊ̔g`
//								int	 	i_data_num,				//	[INPUT]		g`̃f[^_			[MAX: 8192]
//								double	*f_work,				//  [INPUT]		[NGA̐擪|C^
//								int 	i_down_sample_rate )	//	[INPUT]		_ETvO[g (1:_ETvȂ)
//																//	߂lF	ϊ̃f[^_
//																//				  	_ETv:     i_data_num-(tB^W̐[150])/2
//																//					_ETvO: L / i_down_sample_rate
//																//	FilterW	150
// ******************************************************************************************************************
int 	app_EWO_decimation_32(	double 	*f_data,				//	[IN/OUT]	g`ѕϊ̔g`
								int	 	i_data_num,				//	[INPUT]		g`̃f[^_			[MAX: 8192]
								double	*f_work,				//  [INPUT]		[NGA̐擪|C^
								int 	i_down_sample_rate )	//	[INPUT]		_ETvO[g (1:_ETvȂ)
																//	߂lF	ϊ̃f[^_
																//				  	_ETv:     i_data_num-(tB^W̐[150])/2
																//					_ETvO: L / i_down_sample_rate
																//	FilterW	150
{
	/*
  	return app_EWO_decimation( 	f_data, 						// [IN/OUT]	Data -> ϊData
  								i_data_num,						// [INPUT]	Data̓_
								f_work,							// [INPUT]		[NGA̐擪|C^
  								i_down_sample_rate, 			// [INPUT]	Down-sampling rate
  								Gf_EWO_DEC_h32, 				// [INPUT]	FilterW 		[31]		(defined in 'app_EWO_variable.c')
  								150 );							// [INPUT]	Filter Number	[31]
																//	߂lFϊ̃f[^_D
	*/
	// tB^Wǁi^bvύXj	2012.08.07 Imachi
  	return app_EWO_decimation( 	f_data, 						// [IN/OUT]	Data -> ϊData
  								i_data_num,						// [INPUT]	Data̓_
								f_work,							// [INPUT]		[NGA̐擪|C^
  								i_down_sample_rate, 			// [INPUT]	Down-sampling rate
  								Gf_EWO_DEC_h32, 				// [INPUT]	FilterW 		[31]		(defined in 'app_EWO_variable.c')
  								156 );							// [INPUT]	Filter Number	[31]
																//	߂lFϊ̃f[^_D
}



// ******************************************************************************************************************
// EWO: Decimation Fiters --- General decimation filter with down sampling
// ------------------------------------------------------------------------------------------------------------------
// int 	app_EWO_decimation (	double	*f_data,				//	[IN/OUT]	g`ѕϊ̔g`
//								int	 	i_data_num,				//	[INPUT]		g`̃f[^_			[MAX: 8192]
//								double	*f_work,				//  [INPUT]		[NGA̐擪|C^
//								int 	i_down_sample_rate, 	//	[INPUT]		_ETvO[g (1:_ETvȂ)
//								double	*f_h,					//	[INPUT]		FilterW
//								int		i_filter_num )			//	[INPUT]		FilterW̐			(1/2: 31,  1/32: 150)
//																//	߂lF	ϊ̃f[^_
//																//				  	_ETv:     i_data_num-(tB^W̐)/2
//																//					_ETvO: L / i_down_sample_rate
// ******************************************************************************************************************
int 	app_EWO_decimation (	double 	*f_data,				//	[IN/OUT]	g`ѕϊ̔g`
								int	 	i_data_num,				//	[INPUT]		g`̃f[^_			[MAX: 8192]
								double	*f_work,				//  [INPUT]		[NGA̐擪|C^
								int 	i_down_sample_rate, 	//	[INPUT]		_ETvO[g (1:_ETvȂ)
								double	*f_h,					//	[INPUT]		FilterW
								int		i_filter_num )			//	[INPUT]		FilterW̐			(1/2: 31,  1/32: 150)
																//	߂lF	ϊ̃f[^_
																//				  	_ETv:     i_data_num-(tB^W̐)/2
																//					_ETvO: L / i_down_sample_rate
{
	int		shift;
	int		i, j;

	// *** Check the length ***
//	if (i_data_num > Gd_EWO_DEC_MAX)  return(0);				// ***8192***
	
	// *** Error check and initialize ***
	if( i_down_sample_rate < 1 ) i_down_sample_rate = 1;
	for( i=0; i<i_data_num; i++ ) f_work[i] = 0;
	
	// *** Apply filer ***
	for( i=0; i<i_data_num; i+= i_down_sample_rate ){
		for( j=0; j<i_filter_num; j++ ){
			if( i >= j ){
				f_work[i/i_down_sample_rate] += f_h[j] * f_data[i-j];
			}
		}
	}
	
	// *** Produce output ***
	// Ԉ̏ꍇŁCtB^W̏ꍇCP_炷D
	if( i_down_sample_rate != 1 && ( i_filter_num %2 ) != 0 )	shift = 1;
	else														shift = 0;
	// o̓f[^̐
	for( i=0, j=0; i<(i_data_num - i_filter_num)/i_down_sample_rate; i++ ){
		f_data[j++] = f_work[i + ( i_filter_num - 1 ) / i_down_sample_rate + shift];
	}
	
	// *** Return the number of the data ***
  	return (j);
}

