/*******************************************************************************
*   W[      FO[oϐ`                                   *
*   W[x    FvariableApp MGF                                      *
*   ^XN敪          Fwb_                                               *
*   @\                FO[oϐ`s                             *
*   gp̒        FɂȂ                                             *
*   쐬E쐬      F2009/08/20    Y.K.                                   *
*   				F  EDIT́AMGFg                                  *
*   XVEXV      F2011/09/03    A. Matsuoka                            *
*                       F2011/09/14    A. Matsuoka                            *
*                                       Gui_MGF_sunpulseTI_* 폜              *
*                                       Wϊ}gbNXl             *
*                       F2011/10/11    Y.K. (SystemϐƂ̐)              *
*   E      F2012/05/29    A. Matsuoka ȉ̃p[^l     *
*                                       Guc_MGF_HK, Gul_MGF_buff_ti            *
*                                       Guc_MGF_TLM_stat ̃TCY              *
*                                       Gl_MGF_TLM_stat_len ̒l               *
*   E      F2012/06/06    A. Matsuoka                            *
*   E      F2013/11/08    A. Matsuoka                            *
*                                       SW parameter set command length        *
*   E      F2013/11/19    A. Matsuoka                            *
*******************************************************************************/


#include "dpu_api.h"
#include "app_common.h"

/* MGF basic parameters */
unsigned char Guc_node_mgf[2] = { Gd_N_MGFO, Gd_N_MGFI } ;
unsigned short Gus_MGF_packet_def_n_in_block = 9 ;  /* defined packet number in a block */
unsigned short Gus_MGF_data_def_n_in_packet = 18 ;  /* defined data number in a packet */
unsigned short Gus_MGF_app_m[2] = {3, 13} ;
long Gl_MGF_mss_block_len = 2016 ;  // Block length of MGF mission data = 224x9
// note: 1 block every seconds.  1 block consists of 9 packets.
long Gl_MGF_mss_packet_len = 224 ;
long Gl_MGF_dat_packet_len = 202 ;
unsigned short Gus_MGF_TLM_CO_header_length = 18 ;

/* Parameters for commanding */
long Gl_MGFO_Cmm_n = 0 , Gl_MGFI_Cmm_n = 0, Gl_MGFO_Mrr_n = 0, Gl_MGF_SwP_n[2] = {0, 0} ;
unsigned char Guc_MGFO_Cmm_Param[30][3], Guc_MGFO_Mrr_Param[32][3], Guc_MGFI_Cmm_Param[4] ;
unsigned char Guc_MGF_Sw_Param[2][5][20];
unsigned char Guc_MGF_TLM_Param[2][8] = {{0, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 0}} ;
short Gs_MGF_dt_offset[2] = {0, 0};  // new 20110902

/* Parameters for mission data store */
long Gl_MGF_mss_block[2] ; // newly read block number
unsigned char Guc_MGF_raw[2][5][9][202] ;  // mission data output from MGF  // 6 -> 5 20131119
long Gl_MGF_full[2][3][780][3], Gl_MGF_last_1s[2][3][130][3] ;
long Gl_MGF_full_dt[2][3][780], Gl_MGF_last_1s_dt[2][3][130] ;  // type change 20110902
unsigned char Guc_MGF_last_1s_n[2][3] = {{0, 0, 0}, {0, 0, 0}} ;
unsigned short Gus_MGF_full_length = 780, Gus_MGF_last_1s_length = 128 ;  // new 20110902
unsigned int Gui_MGF_TLM_block_TI[2];		// , Gui_MGF_TLM_lastblock_TI[2]= { 0, 0 } ;  // TI of read block		**** rev by YK 111012 ****

/* Parameters for HK data */
unsigned char Guc_MGF_HK[2][20] ;

/* buffer status */
unsigned short Gus_MGF_buff_in_store[2] = { 0, 0 } ; // curently storing buffer
unsigned short Gus_MGF_buff_n[2][3] = {{0, 0, 0}, {0, 0, 0}} ;  // data count stored in the buffer
unsigned short Gus_MGF_buff_stat[2][3] = {{9, 0, 0}, {9, 0, 0}} ;  // buffer status, initialize = empty
unsigned long Gul_MGF_buff_ti[2][3] = {{0, 0, 0}, {0, 0, 0}} ;  // TI of the buffer
unsigned long Gul_MGF_spin_n[2] = { 0, 0 } ;

/* Physical parameters */
unsigned short Gus_MGF_t_step[2] = { 75, 79 } ;  // nominal dt step
unsigned short Gus_MGF_dt_unit[2] = { 104, 100 } ;  // typical dt unit in usec
unsigned short Gus_MGF_ti_unit = 1953 ;  // TI unit in usec
unsigned short Gus_MGF_ti_step_1hz = 512 ;
unsigned long Gul_MGF_spin_prd[2] ;
long Gl_MGF_ave[2][3] = {{0, 0, 0}, {0, 0, 0}} ;  // average for spin period
long Gl_MGF_sub[2][3] = {{0, 0, 0}, {0, 0, 0}} ;  // specified major component to subtract for compression
long Gl_MGF_mjr[2][3] = {{0, 0, 0}, {0, 0, 0}} ;  // major component for compression
short Gs_MGF_off[2][3] = {{0, 0, 0}, {0, 0, 0}} ;  // offset to subtract from average for spin fit
short Gs_MGF_spin_fit[2][3][3] ;
// Gs_MGF_cnv[uc_mgfoi][sc x/y/z][mgf x/y/z][sin(a)/cos(b)/dcb]
short Gs_MGF_cnv[2][3][3][3] ;
// = { {0, 0, 0}, {0, 0,     0}, {11585,  11585, 0},   // MGF-O sc-x
//	                             {0, 0, 0}, {0, 0,     0}, {11585, -11585, 0},   // MGF-O sc-y
//	                             {0, 0, 0}, {0, 0, 16384}, {    0,      0, 0},   // MGF-O sc-z
//	                         
//	                             {-11585, -11585, 0}, {0, 0, 0}, {0, 0,     0},   // MGF-I sc-x
//	                             {-11585,  11585, 0}, {0, 0, 0}, {0, 0,     0},   // MGF-I sc-y
//	                             {     0,      0, 0}, {0, 0, 0}, {0, 0, 16384} }; // MGF-I sc-z
short Gs_MGF_cnv_const_xy = 11585 ;
short Gs_MGF_cnv_const_z = 16384 ;
unsigned short Gus_MGF_rng_shift[2][3] ;
unsigned char Guc_MGF_1s_n[2] ;
short Gs_MGF_TRG[2][4] ;  // new 20110902

/* Mission telemetry data parameter and storage */
unsigned char Guc_MGF_mjr_flag[2][3] = {{0x08, 0x08, 0x08}, {0x08, 0x08, 0x08}} ;  // flag of the major component, initial:averaged value
unsigned char Guc_MGF_shift_flag[2][3] = {{0x08, 0x08, 0x08}, {0x08, 0x08, 0x08}} ;  // flag of the bit shift, initial:automatic
unsigned char Guc_MGF_TLM_out[2][3] = {{1, 1, 0}, {1, 1, 0}} ;  // flag of the telemetry output for L, M, H = (out, out, non) in default
unsigned char Guc_MGF_TLM_rate[2][3] = {{0x01, 0x08, 0x0C}, {0x01, 0x08, 0x0C}} ;  // flag of the telemetry mode for L, M, H = (spn, 8Hz, CO) in default
unsigned char Guc_MGF_TLM_header_com[2][15], Guc_MGF_TLM_header_ML[2][22] ;  // changed 20110902
unsigned long Gul_MGF_ML_start_ti[2] ;
unsigned char Guc_MGF_hmode[2][810], Guc_MGF_8hz[2][310], Guc_MGF_4hz[2][170] ;
unsigned short Gus_MGF_Sw_Param_n[2] = {0, 0} ; // new 20110903
// unsigned short Gus_MGF_TLM_ML_header_length = 40 ; // delete 20131108 Matsuoka
#ifdef TLM_STAT
unsigned char Guc_MGF_TLM_stat[2][128] ;  // changed 20120529
long Gl_MGF_TLM_stat_len=128 ;  // changed 20120529
#endif

unsigned char Guc_MGF_TLM_Mmode[2][1500] ;  // data put to M-mode packet, add 20131108 Matsuoka
unsigned char Guc_MGF_TLM_Lmode[2][400]  ;  // data put to L-mode packet, add 20131108 Matsuoka
int Gi_MGF_TLM_data_n[2][3] = {{0, 0, 0}, {0, 0, 0}} ;  // data length of the packet, add 20131108 Matsuoka
unsigned char Guc_MGF_TLM_spin_n[2][3] = {{0, 0, 0}, {0, 0, 0}} ;  // number of spins in the packet, add 20131108 Matsuoka
unsigned int Gui_MGF_TLM_ti[2][3] ;  // start TI of the packet, add 20131108 Matsuoka

