/*******************************************************************************
*                                                                              *
*   W[      F`FbNAEg֘A`                           *
*   W[x    Fcheckout.h                                           *
*   ^XN敪          F`FbNAEgAv                                 *
*                                                                              *
*******************************************************************************/
#include "dpu_api.h"    /* MiddleWare API`       */

/* ------ define` ------ */
/* S */
#define d_CO_NODE_DPU1  0x03
#define d_CO_NODE_DPU2  0x04
#define d_CO_CHKOUT_START   0x01
#define d_CO_CHKOUT_EXIT    0x0F
#define d_CO_SIZEOF_CMDBUFF_I   67      /* R}hf[^i[̈TCY */
#define d_CO_SIZEOF_TLMBUFF_I   62      /* egf[^i[̈TCY */	/* DMC TM Packet΍ */

/* CheckOut Cmd֘A */
#define d_CO_PLAN_OFFSET_I                  3       /* CheckOut Plan No.1JnAhX܂ł̃ItZbg */
#define d_CO_PLAN_SIZE_I                    4       /* 1 CheckOut Plañf[^TCY */
#define d_CO_PLANCOUNT_MAX                  15      /* Planől */
#define d_CO_SIZEOF_READSIZE_PER_CHK_B      2048    /* 1񂠂̃f[^擾TCY */
#define d_CO_SIZEOF_READSIZE_PER_CHK_I      512     /* 1񂠂̃f[^擾TCY */
#define d_CO_SIZEOF_WRITESIZE_PER_CHK_B     d_CO_SIZEOF_READSIZE_PER_CHK_B    /* 1񂠂̃f[^TCY */
#define d_CO_SIZEOF_WRITESIZE_PER_CHK_I     d_CO_SIZEOF_READSIZE_PER_CHK_I    /* 1񂠂̃f[^TCY */

/* CheckOut Tlm֘A */
#define d_CO_NO_ERROR            0      /* G[Ȃ */
#define d_CO_SUM_ERROR          -1      /* Tlsv */
#define d_CO_NODEID_ILLIGAL     -2      /* NodeIDُl */
#define d_CO_RDN_OFF            -3      /* 璷OFF */
#define d_CO_ROM_READ_ERROR     -4      /* ROMǍG[ */
#define d_CO_RDN_WRITE_ERROR    -5      /* 璷G[ */
#define d_CO_RDN_READ_ERROR     -6      /* 璷ǍG[ */
#define d_CO_GEN_ERROR          -7      /* ̑G[ */
#define d_CO_CHKOUT_TLM_APID_DPU1   0x0619
#define d_CO_CHKOUT_TLM_APID_DPU2   0x0621
#define d_CO_CHKOUT_TLM_CATEGORY    0x29
#define d_CO_CHKOUT_TLM_PKTID       0x80
#define d_CO_CHKOUT_RESULT_OFFSET_B 4        /* CheckOut Result No.1JnAhX܂ł̃ItZbg */
#define d_CO_CHKOUT_RESULT_SIZE_B   16       /* 1 CheckOut Result̃f[^TCY */
#define d_CO_CHKOUT_RESULT_SIZE_I   4        /* 1 CheckOut Result̃f[^TCY */


/* ------ p̒` ------ */
typedef union {
    unsigned int    ui;
    unsigned short  us[2];
    unsigned char   uc[4];
}APP_U_CHKOUT_BUFF;


/* ------ \̒` ------ */
/* CheckOut Plan */
typedef struct {
    unsigned char   uc_nodeID;          /* `FbNΏۂNodeID */
    unsigned char   uc_writeValue;      /* ݒl */
    unsigned int    ui_readSize;        /* 񂠂̃[hTCY */
    unsigned int    ui_startAddr;       /* ǏoJnAhX */
    unsigned int    ui_endAddr;         /* ǏoŏIAhX */
    unsigned int    ui_sumValue;        /* Tl̊Ғl */
} APP_T_CHKOUT_PLAN;

/* CheckOut Result */
typedef struct {
    unsigned char   uc_nodeID;          /* `FbNΏۂNodeID */
    unsigned char   uc_resultCode;      /* ݒl */
    unsigned char   uc_apiReturn;       /* ݒl */
    unsigned int    ui_startAddr;       /* ǏoJnAhX */
    unsigned int    ui_endAddr;         /* ǏoŏIAhX */
    unsigned int    ui_sumValue;        /* TľvZ */
} APP_T_CHKOUT_RESULT;


/* O[oϐ` */
extern APP_U_CHKOUT_BUFF   Gu_co_cmdBuff[d_CO_SIZEOF_CMDBUFF_I];      /* R}hf[^i[̈ */
extern int                 Gi_cmdSize;                                /* R}hpPbgTCY */
extern APP_U_CHKOUT_BUFF   Gu_co_tlmDataBuff[d_CO_SIZEOF_TLMBUFF_I];  /* egf[^i[̈ */
extern APP_T_CHKOUT_PLAN   Gt_co_chkOutPlan;
extern APP_T_CHKOUT_RESULT Gt_co_chkOutResult;
extern unsigned int        Gui_co_readData[d_CO_SIZEOF_READSIZE_PER_CHK_I];    /* f[^i[̈ */
extern unsigned int        Gui_co_writeData[d_CO_SIZEOF_WRITESIZE_PER_CHK_I];  /* ݃f[^i[̈ */
extern M_T_CCSDS_HDR_INFO  Gt_co_chkoutTlmInfo;        /* e */

/* ֐vg^Cv錾 */
void checkout_init( void );
int checkout_cmdProc( void );
void checkout_fin( void );
int checkout_getCmd( void );
int checkout_putTlm( M_T_CCSDS_HDR_INFO *tp_tlmInfo, int i_size, unsigned char *ucp_buff, int *ip_busyFlag );
int checkout_putRdn( unsigned int *uip_buffer, unsigned int ui_addr, unsigned int ui_size );
int checkout_getRdn( unsigned int ui_addr, unsigned int ui_size, unsigned int *uip_buffer );
int checkout_getRom( unsigned int ui_addr, unsigned int ui_size, unsigned int *uip_buffer );
void checkout_startWDT( void );
void checkout_resetWDT( void );
void checkout_stopWDT( void );
void checkout_run(void);
void checkout_resetData( void );
void checkout_procCheckOut(void);
void checkout_getPlan(unsigned short us_planNo);
int checkout_getMemData(unsigned int ui_addr, int *i_apiResult);
unsigned int checkout_calcSum( void );
void checkout_setResult( void );
void checkout_putResult( void );


