/*******************************************************************************
*                                                                              *
*   W[      FubNAhXvZ                                 *
*   W[x    Frap_mm_calcBlockAddr                                 *
*   ^XN敪          F璷Cu                                       *
*   @\                F~bVf[^M̈JnAhXƂ     *
*                         ubNԍ̃ubNJnAhXvZ         *
*                                                                              *
*   R[OV[PXFint rap_mm_calcBlockAddr( nodeID, missionDataID,     *
*                                              startAddr, blockNo, &blockAddr )*
*                   Fint          nodeID        F~bV@ID        *
*                         int          missionDataID F~bVf[^ID      *
*                         unsigned int startAddr     F~bVf[^M̈*
*                                                      JnAhX            *
*                                                      (0x08100000`0x17FFFFFF)*
*                         int          blockNo       FubNԍ            *
*                         unsigned int blockAddr     FubNJnAhX    *
*   ߂l              F ( <0 :ُ , 0:)                        *
*                          0 FI                                        *
*                         -1 FnodeID~bV@IDłȂ                  *
*                         -2 F~bVf[^M̈JnAhXSDRAM̈O*
*                         -3 FubNԍ̗̈悪SDRAM ̈O                *
*   gp̒        FȂ                                                 *
*   G[          FȂ                                                 *
*                                                                              *
*******************************************************************************/
#include "dpu_api.h"
#include "dpu_api_proto.h"
#include "rap_api.h"
#include "rap_define.h"             /* define`               */
#include "rap_variable.h"           /* O[oϐ錾       */
#include "rap_func.h"               /* ֐vg^Cv錾     */

int rap_mm_calcBlockAddr( int nodeID,
                          int missionDataID,
                          unsigned int startAddr,
                          int blockNo,
                          unsigned int *blockAddr )
{
    int     i_ret = 0;      /* ߂l */
    
    M_T_MIS_DATA_PLAN info;


    /* ubNTCY擾inodeID`FbNj */
    i_ret = rap_mm_getMisDataPlan( nodeID, missionDataID, &info );
    
    /* JnAhX`FbN */
    if( startAddr < RA_d_SDRAM_SADDR )
    {
        /* AhX͈͊O */
        i_ret = -2;
    }
    
    /* ubNJnAhXvZ */
    *blockAddr = startAddr + info.ui_blockSize * blockNo;
    
    /* ubNAhX`FbN */
    if( RA_d_SDRAM_SADDR >  *blockAddr                          ||
        RA_d_SDRAM_EADDR < (*blockAddr + info.ui_blockSize - 1) )
    {
        /* AhX͈͊O */
        i_ret = -3;
    }
    

    return i_ret;
}


