/*******************************************************************************
*                                                                              *
*   W[      FvCAhXvZ                                 *
*   W[x    Frap_mm_calcReplyAddr                                 *
*   ^XN敪          F璷Cu                                       *
*   @\                F~bVf[^M̈JnAhXƂāA   *
*                         w肳ꂽubN̂Aw肳ꂽvCԍ   *
*                         vCJnAhXvZ                       *
*                                                                              *
*   R[OV[PXFint rap_mm_calcReplyAddr( nodeID, misshonDataID,     *
*                                     startAddr, blockNo, replyNo, &replyAddr )*
*                   Fint nodeID F~bV@ID                        *
*                         int missionDataID F~bVf[^ID               *
*                         unsigned int startAddr F~bVf[^M̈Jn*
*                                                  AhX                    *
*                                                   (0x08100000`0x17FFFFFF)   *
*                         int blockNo FubNԍ                           *
*                         int replyNo F擾Reply ԍ                     *
*                         unsigned int replyAddr FyózReply JnAhX  *
*   ߂l              F ( <0 :ُ , 0:)                        *
*                          0 FI                                        *
*                         -1 FnodeID~bV@IDłȂ                  *
*                         -2 F~bVf[^̈JnAhXSDRAM̈O   *
*                         -3 FubNԍ̗̈悪SDRAM̈O                 *
*   gp̒        FȂ                                                 *
*   G[          FȂ                                                 *
*                                                                              *
*******************************************************************************/
#include "dpu_api.h"
#include "dpu_api_proto.h"
#include "rap_api.h"
#include "rap_define.h"             /* define`               */
#include "rap_variable.h"           /* O[oϐ錾       */
#include "rap_func.h"               /* ֐vg^Cv錾     */

int rap_mm_calcReplyAddr( int nodeID,
                          int missionDataID,
                          unsigned int startAddr,
                          int blockNo,
                          int replyNo,
                          unsigned int *replyAddr )
{
    unsigned int    ui_blockAddr;
    int             i_ret = 0;      /* ߂l */
    
    M_T_MIS_DATA_PLAN info;


    /* ubNTCY擾inodeID`FbNj */
    i_ret = rap_mm_getMisDataPlan( nodeID, missionDataID, &info );
    
    /* JnAhX`FbN */
    if( startAddr < RA_d_SDRAM_SADDR )
    {
        /* AhX͈͊O */
        i_ret = -2;
    }
    
    /* vCJnAhXvZ */
    ui_blockAddr =    startAddr + info.ui_blockSize * blockNo;
    *replyAddr   = ui_blockAddr + info.ui_replySize * replyNo;
    
    /* ubNAhX`FbN */
    if( RA_d_SDRAM_EADDR >  *replyAddr                          ||
        RA_d_SDRAM_EADDR < (*replyAddr + info.ui_replySize - 1) )
    {
        /* AhX͈͊O */
        i_ret = -3;
    }
    

    return 0;
}
