/*******************************************************************************
*                                                                              *
*   W[      F璷lrheZbg                               *
*   W[x    Frap_sv_resetRdnMisIf                                 *
*   ^XN敪          F璷Cu                                       *
*   @\                Fw肵~bV@ɑΉ~bVI/F H/W  *
*                         ZbgB                                       *
*                                                                              *
*   R[OV[PXFint rap_sv_resetRdnMisIf( nodeID, lowerAddr,         *
*                                                   upperAddr)                 *
*                   Fint          nodeID    F~bV@ID            *
*                         unsigned int lowerAddr F]AhX          *
*                         unsigned int upperAddr F]AhX          *
*                                 F0x08100000`0x17F00000A16oCgPʎw *
*   ߂l              F ( <0 :ُ , 0:)                        *
*                          0 FI                                        *
*                         -1 FDPU ~bV@                          *
*                         -2 FlowerAddr yupperAddr w͈͊O            *
*                         -3 FLȊÖُ                                  *
*   gp̒        F`FbNȂ̂ŏʃW[ł邱       *
*   G[          F߂lɕlp                   *
*                                                                              *
*******************************************************************************/
#include "dpu_api.h"
#include "dpu_api_proto.h"
#include "rap_api.h"
#include "rap_define.h"             /* define`               */
#include "rap_variable.h"           /* O[oϐ錾       */
#include "rap_func.h"               /* ֐vg^Cv錾     */
#include "app_rdn_core.h"

#define BUFF_SIZE 15

int rap_sv_resetRdnMisIf( int nodeID,
                          unsigned int lowerAddr,
                          unsigned int upperAddr )
{
    int             i;
    unsigned int    ui;
    unsigned short  us_setValue[BUFF_SIZE];              /* WX^ݒli[ */
    unsigned int    ui_size = RA_d_SHORT * BUFF_SIZE;    /* i[̈TCY */
    char            c_channel;
    char            c_dpuIndex;
    int             i_sendResult;

    unsigned char   *ucp_msReadCmd;
    unsigned char   uc_logicalAddr;
    unsigned char   uc_msReadPktType;
    unsigned int    ui_msReadAddr;
    unsigned int    ui_msReadSize;
    
    /* `FbN */
    c_channel = Gc_CHID[ nodeID ];
    if( c_channel < 0 || c_channel >= RA_d_MISSION_NUM )
    {
// ---comment out:110615 ---	        rap_cmm_putDbgTlm( c_channel );
        return -1;
    }
    if( lowerAddr > upperAddr )
    {
        return -2;
    }
    if(   lowerAddr <  0x08100000
       || lowerAddr >  0x17F00000
       || ( lowerAddr %  0x00200000 ) != 0 )
    {
        return -2;
    }
    if(   upperAddr <  0x08100000
       || upperAddr >  0x17F00000
       || ( upperAddr %  0x00200000 ) != 0 )
    {
        return -2;
    }
    
    /* R}hMRg[WX^    FG[Xe[^XNA    */
    us_setValue[0] = 0x0F00;
    /* R}hMRg[EWX^    FG[Xe[^XNA    */
    us_setValue[1] = 0x1F00;
    /* R}hMݒEWX^            FiݒΏۊOj            */
    us_setValue[2] = 0x0000;
    /* RMAP MXe[^XEWX^             FMCl[uݒ        */
    /*                                           FG[JE^NA      */
    us_setValue[3] = 0x1001;
    /* RMAP Read Reply0 MEWX^       FMNA            */
    us_setValue[4] = 0x0001;
    /* DMA]AhX0EWX^              FiݒΏۊOj            */
    us_setValue[5] = 0x0000;
    us_setValue[6] = 0x0000;
    /* RMAP Read Reply1 MEWX^       FMNA            */
    us_setValue[7] = 0x0001;
    /* DMA]AhX1EWX^              FiݒΏۊOj            */
    us_setValue[8] = 0x0000;
    us_setValue[9] = 0x0000;
    /* RMAP Write Reply MEWX^       FMNA            */
    us_setValue[10] = 0x0001;
    /* RMAP Write Command MEWX^     FMNA            */
    us_setValue[11] = 0x0001;
    /* ]AhXLower Limit ݒEWX^  FlowerAddr ɏ]lɐݒ  */
    us_setValue[12] = (unsigned short)((( lowerAddr - RA_d_SDRAM_BASE_ADDR ) 
                                         & 0x0FE00000 ) >> 16 );
    /* ]AhXUpper Limit ݒEWX^  FupperAddr ɏ]lɐݒ  */
    us_setValue[13] = (unsigned short)((( upperAddr - RA_d_SDRAM_BASE_ADDR ) 
                                         & 0x0FE00000 ) >> 16 );
    /* RCV Buffer EDAC G[Xe[^XEWX^FG[Xe[^XNA    */
    us_setValue[14] = 0x0003;

    i_sendResult = rap_cmm_setRdnRegister( (unsigned char *)us_setValue, 
                                           RA_Gui_msRegStartAddr[(int)c_channel],
                                           RA_d_MSREG_SGLSDCTL,             // ݐ̐擪WX^
                                           ui_size                      );
    if( i_sendResult < 0 )
    {
// ---comment out:110615 ---	        rap_cmm_putDbgTlm( i_sendResult );
        return -3;
    }

    /* ~bVf[^WR}h */
    c_dpuIndex      = rap_cmm_getRdnDpuIndex();
    uc_logicalAddr  = RA_Gt_missionInfo[(int)c_dpuIndex][(int)c_channel].uc_logicalAddr;
    ui_msReadAddr   = RA_Gt_missionInfo[(int)c_dpuIndex][(int)c_channel].ui_msDataBuffer;
    ui_msReadSize   = RA_Gt_missionInfo[(int)c_dpuIndex][(int)c_channel].ui_readSize;
    if(RA_Gt_missionInfo[(int)c_dpuIndex][(int)c_channel].uc_incr == 1)
    {
        uc_msReadPktType = 0x4C;    /* Incr    : 01001100 */
    }else{
        uc_msReadPktType = 0x48;    /* No-Incr : 01001000 */
    }
    ucp_msReadCmd = (unsigned char *)RA_Gus_misClctCmd[(int)c_channel];
    for( i = 0; i < RA_Gt_missionInfo[(int)c_dpuIndex][(int)c_channel].uc_number; i++ )
    {
        *ucp_msReadCmd = uc_logicalAddr; /* Logical Address */
        ucp_msReadCmd++;
        *ucp_msReadCmd = 0x01;    /* Protocol Identifier (RMAP=0x01) */
        ucp_msReadCmd++;
        *ucp_msReadCmd = uc_msReadPktType;    /* PacketType,Command,SourcePathAddrLen  */
        ucp_msReadCmd++;
        *ucp_msReadCmd = 0x00;    /* DestinationKey (0x00Œ) */
        ucp_msReadCmd++;
        *ucp_msReadCmd = 0x20;    /* Source Logical Address (0x20Œ) */
        ucp_msReadCmd++;
        *ucp_msReadCmd = RA_d_SPW_MSREAD;  /* Transaction Identifier MS (MSB=0,MSREAD) */
        ucp_msReadCmd++;
        *ucp_msReadCmd = (unsigned char)i;       /* Transaction Identifier LS (Counter) */
        ucp_msReadCmd++;
        *ucp_msReadCmd = 0x00;    /* Extended Write Address (0x00Œ) */
        ucp_msReadCmd++;

		memcpy( ucp_msReadCmd, &ui_msReadAddr, 4);	ucp_msReadCmd += 4;
		/*
        *ucp_msReadCmd = (unsigned char)((ui_msReadAddr >> 24) & 0xFF); // Write Address
        ucp_msReadCmd++;
        *ucp_msReadCmd = (unsigned char)((ui_msReadAddr >> 16) & 0xFF);
        ucp_msReadCmd++;
        *ucp_msReadCmd = (unsigned char)((ui_msReadAddr >>  8) & 0xFF);
        ucp_msReadCmd++;
        *ucp_msReadCmd = (unsigned char)((ui_msReadAddr      ) & 0xFF);
        ucp_msReadCmd++;
        */

		ui = (ui_msReadSize << 8);
		memcpy( ucp_msReadCmd, &ui, 3);	ucp_msReadCmd+=3;
		/*
        *ucp_msReadCmd = (unsigned char)((ui_msReadSize >> 16) & 0xFF); // Data Length 
        ucp_msReadCmd++;
        *ucp_msReadCmd = (unsigned char)((ui_msReadSize >>  8) & 0xFF);
        ucp_msReadCmd++;
        *ucp_msReadCmd = (unsigned char)((ui_msReadSize      ) & 0xFF);
        ucp_msReadCmd++;
        */
    }
    
    /* I */
    return 0;
}
