/*******************************************************************************
*                                                                              *
*   W[      F璷[hM                                 *
*   W[x    Frap_sv_sendRdnMemLoad                                *
*   ^XN敪          F璷Cu                                       *
*   @\                F~bV@ɑ΂Aw肵AhXփAvP[   *
*                         Vpf[^̈悩w肵TCỸf[^   *
*                         RMAP Write Command𑗐MB                   *
*                                                                              *
*   R[OV[PXFint rap_sv_sendRdnMemLoad( nodeID, address, size,    *
*                                                    loadBuff )                *
*                   Fint           nodeID        F~bV@ID       *
*                         unsigned int  address       F[hAhX         *
*                         int           size          F[hTCY           *
*                         unsigned char loadBuff[163] F[hf[^           *
*                                        iRMAP Write Command Data ̂݁j*
*   ߂l              F ( <0 :ُ , 0:)                        *
*                          0 FI                                        *
*                         -1 FDPU~bV@                           *
*                         -2 F[hTCYől𒴂                    *
*                         -3 FLȊO                                        *
*   gp̒        FȂ                                                 *
*   G[          FȂ                                                 *
*                                                                              *
*******************************************************************************/
#include "dpu_api.h"
#include "dpu_api_proto.h"
#include "rap_api.h"
#include "rap_define.h"             /* define`               */
#include "rap_variable.h"           /* O[oϐ錾       */
#include "rap_func.h"               /* ֐vg^Cv錾     */
#include "app_rdn_core.h"

#define RMAP_PKT_SIZE_MAX   (15+163)

int rap_sv_sendRdnMemLoad(  int           nodeID,
                            unsigned int  address,
                            int           size,
                            unsigned char loadBuff[]  )
{
    // int             i;
    
    unsigned short  us_buff[89];
    unsigned char   *ucp_buff;
    char            c_msChannel;   /* ~bV`li0-7j */
    char            c_dpuIndex;    /* 璷DPUCfbNX       */
    unsigned int    ui_writeAddr;
    unsigned int    ui_writeSize;
    int             i_result;   /* R}hM */
    
    /* Jn */
    
    /* `FbN */
    c_msChannel = Gc_CHID[ nodeID ];
    c_dpuIndex = rap_cmm_getRdnDpuIndex();
    if( c_msChannel < 0 || c_msChannel >= RA_d_MISSION_NUM )
    {
// ---comment out:110615 ---	        rap_cmm_putDbgTlm( c_msChannel );
        return -1;
    }
    if( c_dpuIndex == 0 )
    {
        if( nodeID >= RA_d_NODE_MGF_I )
        {
            return -1;
        }
        
    }else{
        if( nodeID <  RA_d_NODE_MGF_I ||
            nodeID == RA_d_NODE_EWO_B )
        {
            return -1;
        }
        
    }

    if( size < 0 || size > 163 )
    {
        return -2;
    }
    
    /* R}h */
    ui_writeAddr = address;
    ui_writeSize = size;
    
    ucp_buff = (unsigned char *)us_buff;   //big endian
    *ucp_buff = RA_Gt_missionInfo[(int)c_dpuIndex][(int)c_msChannel].uc_logicalAddr; /* Logical Address */
    ucp_buff++;
    *ucp_buff = 0x01; /* Protocol Identifier (RMAP=0x01) */
    ucp_buff++;
    *ucp_buff = 0x64; /* PacketType,Command,SourcePathAddrLen 01101100 */
    ucp_buff++;
    *ucp_buff = 0x00; /* DestinationKey (0x00Œ) */
    ucp_buff++;
    *ucp_buff = 0x20; /* Source Logical Address (0x20Œ) */
    ucp_buff++;
    *ucp_buff = RA_d_SPW_MEMLOAD; /* Transaction Identifier MS (MSB=0,MS-Command) */
    ucp_buff++;
    *ucp_buff = RA_Guc_rmapCnt[(int)c_msChannel][RA_d_SPW_MEMLOAD]; /* Transaction Identifier LS (Counter) */
    ucp_buff++;
    *ucp_buff = 0x00; /* Extended Write Address (0x00Œ) */
    ucp_buff++;

	memcpy( ucp_buff, &ui_writeAddr, 4);	    ucp_buff+=4;
		/*
	    *ucp_buff = (unsigned char)((ui_writeAddr >> 24) & 0xFF); // Write Address MS 
	    ucp_buff++;
	    *ucp_buff = (unsigned char)((ui_writeAddr >> 16) & 0xFF); // Write Address  
	    ucp_buff++;
	    *ucp_buff = (unsigned char)((ui_writeAddr >>  8) & 0xFF); // Write Address  
	    ucp_buff++;
	    *ucp_buff = (unsigned char)( ui_writeAddr        & 0xFF); // Write Address LS 
	    ucp_buff++;
	    */

    ui_writeSize = (ui_writeSize << 8);
	memcpy( ucp_buff, &ui_writeSize, 3);	    ucp_buff+=3;
		/*
	    *ucp_buff = (unsigned char)((ui_writeSize >> 16) & 0xFF); // Data Length MS 
	    ucp_buff++;
	    *ucp_buff = (unsigned char)((ui_writeSize >>  8) & 0xFF); // Data Length  
	    ucp_buff++;
	    *ucp_buff = (unsigned char)( ui_writeSize        & 0xFF); // Data Length LS 
	    */
    /* Header CRC̓n[hݒ */

    /* Data{ */
	memcpy( ucp_buff, &(loadBuff[0]), size);	    ucp_buff+=(size-1);
		/*
	    for( i=0 ; i<size ; i++ )
	    {
	        ucp_buff++;
	        *ucp_buff = loadBuff[i];
	    }
    	*/
    /* Data CRC̓n[hݒ */


    i_result = rap_dr_sendRdnMultiCmd(  c_msChannel, (unsigned char *)us_buff, RMAP_PKT_SIZE_MAX,
                                        1, 1, RA_d_SDRAM_SADDR );
    if( i_result != 0 )
    {
// ---comment out:110615 ---	        rap_cmm_putDbgTlm( i_result );
        return -3;
    }
    
    RA_Guc_rmapCnt[(int)c_msChannel][RA_d_SPW_MEMLOAD]++;
    
    return 0;
}
