/*******************************************************************************
*                                                                              *
*   W[      F璷~bVR}hM                           *
*   W[x    Frap_sv_sendRdnMissionCmd                             *
*   ^XN敪          F璷Cu                                       *
*   @\                F~bV@փ~bVR}hRMAP Write       *
*                         Command𑗐M                                    *
*                                                                              *
*   R[OV[PXFint rap_sv_sendRdnMissionCmd( nodeID, commandBuff,   *
*                                                       dataSize )             *
*                   Fint           nodeID          F~bV@ID     *
*                         unsigned char commandBuff[163]F~bVR}h   *
*                                       iRMAP Write Command Data ̂݁j *
*                         int           dataSize        FcommandBuff Ɋi[   *
*                                                     f[^oCg(byte) *
*   ߂l              F ( <0 :ُ , 0:)                        *
*                           0 FI                                       *
*                          -1 FDPU ~bV@                         *
*                          -2 FLȊÖُ                                 *
*   gp̒        FȂ                                                 *
*   G[          FȂ                                                 *
*                                                                              *
*******************************************************************************/
#include "dpu_api.h"
#include "dpu_api_proto.h"
#include "rap_api.h"
#include "rap_define.h"             /* define`               */
#include "rap_variable.h"           /* O[oϐ錾       */
#include "rap_func.h"               /* ֐vg^Cv錾     */
#include "app_rdn_core.h"

#define RMAP_PKT_SIZE_MAX   178

int rap_sv_sendRdnMissionCmd( int nodeID,
                              unsigned char commandBuff[],
                              int dataSize )
{
    // int i;
    
    unsigned short  us_buff[89];
    unsigned char   *ucp_buff;
    char            c_msChannel;   /* ~bV`li0-7j */
    char            c_dpuIndex;    /* 璷DPUCfbNX       */
    unsigned int    ui_writeAddr;
    unsigned int    ui_writeSize;
    int             i_result;   /* R}hM */
    
    /* Jn */
    
    /* `FbN */
    c_msChannel = Gc_CHID[ nodeID ];
    c_dpuIndex = rap_cmm_getRdnDpuIndex();
    if( c_msChannel < 0 || c_msChannel >= RA_d_MISSION_NUM )
    {
// ---comment out:110615 ---	        rap_cmm_putDbgTlm( c_msChannel );
        return -1;
    }
    if( c_dpuIndex == 0 )
    {
        if( nodeID >= RA_d_NODE_MGF_I )
        {
            return -1;
        }
        
    }else{
        if( nodeID <  RA_d_NODE_MGF_I ||
            nodeID == RA_d_NODE_EWO_B )
        {
            return -1;
        }
        
    }
    if( dataSize < 0 || dataSize > 163 )
    {
        return -2;
    }
    
    /* R}h */
    ui_writeAddr = RA_Gt_missionInfo[(int)c_dpuIndex][(int)c_msChannel].ui_cmdBuffer;
    ui_writeSize = dataSize;
    ucp_buff = (unsigned char *)us_buff;
    
    *ucp_buff = RA_Gt_missionInfo[(int)c_dpuIndex][(int)c_msChannel].uc_logicalAddr; /* Logical Address */
    ucp_buff++;
    *ucp_buff = 0x01; /* Protocol Identifier (RMAP=0x01) */
    ucp_buff++;
    *ucp_buff = 0x6C; /* PacketType,Command,SourcePathAddrLen 01101100 */
    ucp_buff++;
    *ucp_buff = 0x00; /* DestinationKey (0x00Œ) */
    ucp_buff++;
    *ucp_buff = 0x20; /* Source Logical Address (0x20Œ) */
    ucp_buff++;
    *ucp_buff = RA_d_SPW_MSCMD; /* Transaction Identifier MS (MSB=0,MS-Command) */
    ucp_buff++;
    *ucp_buff = RA_Guc_rmapCnt[(int)c_msChannel][RA_d_SPW_MSCMD]; /* Transaction Identifier LS (Counter) */
    ucp_buff++;
    *ucp_buff = 0x00; /* Extended Write Address (0x00Œ) */
    ucp_buff++;

	memcpy( ucp_buff, &ui_writeAddr, 4);	    ucp_buff+=4;
		/*
	    *ucp_buff = (unsigned char)((ui_writeAddr >> 24) & 0xFF); // Write Address MS
	    ucp_buff++;
	    *ucp_buff = (unsigned char)((ui_writeAddr >> 16) & 0xFF); // Write Address  
	    ucp_buff++;
	    *ucp_buff = (unsigned char)((ui_writeAddr >>  8) & 0xFF); // Write Address  
	    ucp_buff++;
	    *ucp_buff = (unsigned char)( ui_writeAddr        & 0xFF); // Write Address LS 
	    ucp_buff++;
	    */

    ui_writeSize = (ui_writeSize << 8);
	memcpy( ucp_buff, &ui_writeSize, 3);	    ucp_buff+=3;
		/*
	    *ucp_buff = (unsigned char)((ui_writeSize >> 16) & 0xFF); // Data Length MS 
	    ucp_buff++;
	    *ucp_buff = (unsigned char)((ui_writeSize >>  8) & 0xFF); // Data Length  
	    ucp_buff++;
	    *ucp_buff = (unsigned char)( ui_writeSize        & 0xFF); // Data Length LS 
	    */
    /* Header CRC̓n[hݒ */

    /* Data{ */
	memcpy( ucp_buff, &(commandBuff[0]), dataSize);	    ucp_buff+=(dataSize-1);
		/*
	    for( i=0 ; i<dataSize ; i++ )
	    {
	        ucp_buff++;
	        *ucp_buff = commandBuff[i];
	    }
	    */
    /* Data CRC̓n[hݒ */


    i_result = rap_dr_sendRdnSingleCmd( c_msChannel, (unsigned char *)us_buff, RMAP_PKT_SIZE_MAX, RA_d_SDRAM_SADDR);
    if( i_result != 0 )
    {
// ---comment out:110615 ---	        rap_cmm_putDbgTlm( i_result );
        return -2;
    }
    
    RA_Guc_rmapCnt[(int)c_msChannel][RA_d_SPW_MSCMD]++;
    
    return 0;
}
